%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct1.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act1x = W(:,4).*cos(W(:,1));
Act1y = W(:,4).*sin(W(:,1));
fid = fopen(['inputAct1_',extstr,'.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau'; Act1x'; Act1y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct2.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act2x = W(:,5).*cos(W(:,2));
Act2y = W(:,5).*sin(W(:,2));
fid = fopen(['inputAct2_',extstr,'.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau'; Act2x'; Act2y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct3.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act3x = W(:,6).*cos(W(:,3));
Act3y = W(:,6).*sin(W(:,3));
fid = fopen(['inputAct3_',extstr,'.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau'; Act3x'; Act3y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%----------- Frequency Modulation Indicator (FMI) ----------------------
d = size(W(:,1),1);
numdata = 2^(floor(log2(d)));
threshold = 16;
FMFT_pick = numdata/2;
%---------------------------------------------------------
n_step = str2num(get(handles.Step_FMI1,'String'));
if n_step >= 1
    delta_step = floor((d - FMFT_pick)/n_step);
    for rr = 1:n_step + 1
        fid = fopen(['inputAct1_',num2str(rr),'_',extstr,'.txt'], 'wt');
        fprintf(fid, '%14.10f %14.10f %14.10f\n',...
            [tau(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act1x(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act1y(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)']);
        fclose(fid);
    end
end
%---------------------------------------------------------
n_step = str2num(get(handles.Step_FMI2,'String'));
if n_step >= 1
    delta_step = floor((d - FMFT_pick)/n_step);
    for rr = 1:n_step + 1
        fid = fopen(['inputAct2_',num2str(rr),'_',extstr,'.txt'], 'wt');
        fprintf(fid, '%14.10f %14.10f %14.10f\n',...
            [tau(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act2x(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act2y(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)']);
        fclose(fid);
    end
end
%---------------------------------------------------------
n_step = str2num(get(handles.Step_FMI3,'String'));
if n_step >= 1
    delta_step = floor((d - FMFT_pick)/n_step);
    for rr = 1:n_step + 1
        fid = fopen(['inputAct3_',num2str(rr),'_',extstr,'.txt'], 'wt');
        fprintf(fid, '%14.10f %14.10f %14.10f\n',...
            [tau(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act3x(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act3y(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)']);
        fclose(fid);
    end
end
%----------------- End FMI ----------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
