function varargout = Kepler(varargin)
%
%
%
%     xxx       xxx
%     xxx      xxx
%     xxx     xxx
%     xxx    xxx
%     xxxxxx       						   
%     xxx    xxx        xxxxxx     xxxxx    xx	     xxxxxx     xxxxx  	
%     xxx     xxx       xx         xx   x   xx	     xx         xx   x 	
%     xxx      xxx      xxxxx      xxxxx    xx	     xxxxx      xxxxx  	
%     xxx       xxx     xx         xx       xx	     xx         xx  x  	
%     xxx        xxx    xx         xx       xx	     xx         xx   x 	 
%     xxx         xxx   xxxxxxxx   xx       xxxxxxx  xxxxxxxx   xx    x	  
%
%
% KEPLER M-file for Kepler.fig
% Created  19-May-2005 
% Last Modified by GUIDE v2.5 29-Mar-2012 19:42:49
%
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Kepler_OpeningFcn, ...
                   'gui_OutputFcn',  @Kepler_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes just before Kepler is made visible.
function Kepler_OpeningFcn(hObject, eventdata, handles, varargin)

handles2 = handles;
clear handles
global handles
handles = handles2;
clear handles2

%%%%%%%%%%%%%%%%%%% HELP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hfcn=['str=get(gco,''Tag'');'...
      'HelpScript'];
set(handles.figureMain,'HelpFcn',Hfcn);
cshelp(handles.figureMain);

keyFcn = ['if strcmp(get(gcbo,''CurrentKey''),''escape''), ' ...
              'set(gcbo,''CSHelpMode'',''off''); ' ...
          'elseif strcmp(get(gcbo,''CurrentKey''),''f2''), ' ...
              'set(gcbo,''CSHelpMode'',''on''); ' ...  
          'end'];     
set(handles.figureMain,'keyPressFcn',keyFcn);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global KeplerDir PhSpGeoDir
if isdeployed
    KeplerDir = cd;
    cd ..
    cd ..
    PhSpGeoDir = cd;
    cd(KeplerDir)
else
    SetPath
end
ColorFont
if ~isnan(findstr(KeplerDir, 'Slave'))
    cd(KeplerDir)
    cd ..
    if exist('Setting.mat')
        load('Setting.mat')
        if Head ~= 4
            set(handles.popupmenu_head, 'Value', 3)       
            set(handles.pushbutton_StartSlave_LGG3, 'Visible', 'on')
            set(handles.uipanel_Freq3D_LGG3, 'Visible', 'on')
        else
            set(handles.popupmenu_head, 'Value', 4)
            set(handles.pushbutton_StartSlave_LSD, 'Visible', 'on')
            set(handles.uipanel_Freq3D_LSD, 'Visible', 'on')
        end
    else
        set(handles.popupmenu_head, 'Value', 3)
        set(handles.pushbutton_StartSlave_LGG3, 'Visible', 'on')
        set(handles.uipanel_Freq3D_LGG3, 'Visible', 'on')
    end
    cd(KeplerDir)
    
    set(handles.pushbutton_Integrate, 'Enable', 'off')
    set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
    set(handles.pushbutton_CalcPlot_Poincare, 'Enable', 'off')    
    set(handles.uipanel_PoincFreq_2D, 'Visible', 'off')
    set(handles.uipanelInit, 'Visible', 'off')
    set(handles.uipanel_AA_FMFT, 'Visible', 'off')
    set(handles.uipanel_RegMethod, 'Visible', 'off')
    set(handles.uipanel_StandMethod, 'Visible', 'off')
    set(handles.uipanel_from_to, 'Visible', 'off')
    if (strcmp(get(handles.LGG3_long_FMFT, 'Checked'),'on') |...
         strcmp(get(handles.LSD_long_FMFT, 'Checked'),'on'))   
        set(handles.LongtimeFA,'Visible', 'on')
    else
        set(handles.LongtimeFA,'Visible', 'off')
    end
    set(handles.uipanel_ClearMemory,'Visible', 'on')
    set(handles.radiobutton_NonPert,'Value', 1)
    set(handles.radiobutton_2D_nonpert,'Value', 1)
    set(handles.radiobutton_NonPert_LGG3,'Value', 1)
    set(handles.radiobutton_NonPert_LSD,'Value', 1)       
    set(handles.edit_OutputStep,'Visible', 'on')
    if str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String'))
        set(handles.ComputeLFA,'String',get(handles.edit_ClearMemory,'String'))  
    end
else
    cd ..
    if exist('multicorefiles')
        rmdir('multicorefiles','s')
    end
    cd(KeplerDir)
end
list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
curdir = [list{dim(1,1), dim(1,2)},' - ',list{dim(1,1) - 1, dim(1,2)}];
set(handles.figureMain, 'Name', curdir)

uiswitchrenderer('auto')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Load saved on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd(KeplerDir)
cd ..
if exist('Setting.mat')
    load('Setting.mat')
    SetInit
end
cd(KeplerDir)
delete FMFT/*.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isdeployed
    set(handles.popupmenuHp1, 'Enable', 'off')
    set(handles.popupmenuHp2, 'Enable', 'off')
    set(handles.popupmenuHp3, 'Enable', 'off')
    set(handles.popupmenuHp4, 'Enable', 'off')
    set(handles.popupmenuHp5, 'Enable', 'off')
    set(handles.edit_epsilon1, 'Enable', 'off')
    set(handles.edit_epsilon2, 'Enable', 'off')
    set(handles.edit_epsilon3, 'Enable', 'off')
    set(handles.edit_epsilon4, 'Enable', 'off')
    set(handles.edit_epsilon5, 'Enable', 'off')
    set(handles.q1_value, 'Enable', 'off')
    set(handles.q2_value, 'Enable', 'off')
    set(handles.q3_value, 'Enable', 'off')
    set(handles.p1_value, 'Enable', 'off')
    set(handles.p2_value, 'Enable', 'off')
    set(handles.p3_value, 'Enable', 'off')
    set(handles.edit_smaxis, 'Enable', 'off')
    set(handles.edit_Eccentricity, 'Enable', 'off')
    set(handles.edit_AscNode, 'Enable', 'off')
    set(handles.edit_ArgPericenter, 'Enable', 'off')
    set(handles.edit_Inclination, 'Enable', 'off')
    set(handles.edit_TrueAnomaly, 'Enable', 'off')
    set(handles.popupmenuODE, 'Enable', 'off')
    set(handles.popupmenuODE,'Value', 1)
    set(handles.radiobutton_Pert, 'Enable', 'off')
    set(handles.radiobutton_NonPert, 'Enable', 'off')
    set(handles.radiobutton_2D_pert, 'Enable', 'off')
    set(handles.radiobutton_2D_nonpert, 'Enable', 'off')
    set(handles.radiobutton_Pert_LGG3, 'Enable', 'off')
    set(handles.radiobutton_NonPert_LGG3, 'Enable', 'off')
    set(handles.radiobutton_Pert_LSD, 'Enable', 'off')
    set(handles.radiobutton_NonPert_LSD, 'Enable', 'off')
    set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
    set(handles.radiobutton_1st, 'Enable', 'off')
    set(handles.radiobutton_2nd, 'Enable', 'off')
    set(handles.edit_S01, 'Enable', 'off')
    set(handles.edit_S02, 'Enable', 'off')
    set(handles.edit_S03, 'Enable', 'off')
    set(handles.edit_D01, 'Enable', 'off')
    set(handles.edit_D02, 'Enable', 'off')
    set(handles.edit_D03, 'Enable', 'off')
    set(handles.edit_Energy, 'Enable', 'off')
    set(handles.edit_EnergyPoincare, 'Enable', 'off')
    set(handles.edit_EnergyLGG3, 'Enable', 'off')
    set(handles.edit_EnergyLSD, 'Enable', 'off')
    set(handles.radiobutton_2D_system, 'Enable', 'off')
    set(handles.Load, 'Enable', 'off')
    set(handles.Save, 'Enable', 'off')
    if ~isnan(findstr(KeplerDir, 'Master'))
        load('Init\SQZcrossed\SQZcrossed_2_02_06_a.mat')
        set(handles.popupmenuHp1,'Value', Hp1)
        set(handles.popupmenuHp2,'Value', Hp2)
        set(handles.popupmenuHp3,'Value', Hp3)
        set(handles.popupmenuHp4,'Value', Hp4)
        set(handles.popupmenuHp5,'Value', Hp5)
        set(handles.edit_epsilon1,'String', epsilon1)
        set(handles.edit_epsilon2,'String', epsilon2)
        set(handles.edit_epsilon3,'String', epsilon3)
        set(handles.edit_epsilon4,'String', epsilon4)
        set(handles.edit_epsilon5,'String', epsilon5)
        set(handles.q1_value,'String', q1)
        set(handles.q2_value,'String', q2)
        set(handles.q3_value,'String', q3)
        set(handles.p1_value,'String', p1)
        set(handles.p2_value,'String', p2)
        set(handles.p3_value,'String', p3)
        set(handles.edit_smaxis,'String', sm)
        set(handles.edit_Eccentricity,'String', ecc)
        set(handles.edit_AscNode,'String', Omega)
        set(handles.edit_ArgPericenter,'String', omega)
        set(handles.edit_Inclination,'String', incl)
        set(handles.edit_TrueAnomaly,'String', f)
        set(handles.edit_S01,'String', SO1)
        set(handles.edit_S02,'String', SO2)
        set(handles.edit_S03,'String', SO3)
        set(handles.edit_D01,'String', DO1)
        set(handles.edit_D02,'String', DO2)
        set(handles.edit_D03,'String', DO3)
    end
end
% Choose default command line output for Kepler
handles.output = hObject;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isnan(findstr(KeplerDir, 'Slave'))
    Totalbar = waitbar(0,'Please wait..., KEPLER is calculating.');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = Kepler_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Save on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object deletion, before destroying properties.
function figureMain_DeleteFcn(hObject, eventdata, handles)
global KeplerDir PhSpGeoDir

if ~isnan(findstr(KeplerDir, 'Slave'))
    %do nothing
else
    if strcmp(get(handles.Save_exit, 'Checked'),'on')     
        cd(KeplerDir)
        InitStructure
        cd ..        
        save('Setting.mat', '-struct', 'InitStr')
        cd(KeplerDir)
    end
end
 
delete FMFT/*.txt
uiswitchrenderer('remove')
%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               Head panel
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on selection change in popupmenu_head.
function popupmenu_head_Callback(hObject, eventdata, handles)
contents = get(hObject,'String');
item = get(hObject,'Value');
txt = char(contents(item));
if strcmp(txt, ' Single orbit analysis ') == 1
    set(handles.uipanel_PoincFreq_2D, 'Visible', 'off')
    set(handles.uipanel_Freq3D_LGG3, 'Visible', 'off')
    set(handles.uipanel_Freq3D_LSD, 'Visible', 'off')
    set(handles.uipanelInit, 'Visible', 'on')
    set(handles.uipanel_AA_FMFT, 'Visible', 'on')
    set(handles.uipanel_RegMethod, 'Visible', 'on')
    set(handles.uipanel_StandMethod, 'Visible', 'on')    
    if (strcmp(get(handles.LGG3_long_FMFT, 'Checked'),'on') |...
               strcmp(get(handles.LSD_long_FMFT, 'Checked'),'on'))   
        set(handles.LongtimeFA,'Visible', 'on')
        set(handles.uipanel_from_to, 'Visible', 'off')
    else
        set(handles.LongtimeFA,'Visible', 'off')
        set(handles.uipanel_from_to, 'Visible', 'on')        
    end 
    set(handles.radiobutton_1st,'Value', 1)
    set(handles.radiobutton_2nd,'Value', 0)
    set(handles.uipanel_ClearMemory,'Visible', 'on')
    set(handles.LGG3_long_FMFT,'Enable', 'on')
    set(handles.LSD_long_FMFT,'Enable', 'on')
elseif strcmp(txt, ' Global analysis: Poincar section ') == 1
    set(handles.uipanel_PoincFreq_2D, 'Visible', 'on')
    set(handles.uipanel_Freq3D_LGG3, 'Visible', 'off')
    set(handles.uipanel_Freq3D_LSD, 'Visible', 'off')  
    set(handles.uipanelInit, 'Visible', 'off')
    set(handles.uipanel_AA_FMFT, 'Visible', 'off')
    set(handles.uipanel_RegMethod, 'Visible', 'off')
    set(handles.uipanel_StandMethod, 'Visible', 'off')
    set(handles.uipanel_from_to, 'Visible', 'off')
    set(handles.popupmenuODE2,'Visible', 'off')
    set(handles.popupmenuODE,'Visible', 'on')
    set(handles.uipanel_GniCodes,'Visible', 'off')
    set(handles.edit_OutputStep,'Visible', 'on')
    set(handles.LongtimeFA,'Visible', 'off')
    set(handles.uipanel_ClearMemory,'Visible', 'off')
    set(handles.LGG3_long_FMFT,'Enable', 'off')
    set(handles.LSD_long_FMFT,'Enable', 'off')    
elseif strcmp(txt, ' Global analysis: Rotated Delaunay ') == 1
    set(handles.uipanel_PoincFreq_2D, 'Visible', 'off')
    set(handles.uipanel_Freq3D_LGG3, 'Visible', 'on')
    set(handles.uipanel_Freq3D_LSD, 'Visible', 'off')
    set(handles.uipanelInit, 'Visible', 'off')
    set(handles.uipanel_AA_FMFT, 'Visible', 'off')
    set(handles.uipanel_RegMethod, 'Visible', 'off')
    set(handles.uipanel_StandMethod, 'Visible', 'off')
    set(handles.uipanel_from_to, 'Visible', 'off')
    if strcmp(get(handles.LGG3_long_FMFT, 'Checked'),'on')   
        set(handles.LongtimeFA,'Visible', 'on')
    else
        set(handles.LongtimeFA,'Visible', 'off')
    end
    set(handles.uipanel_ClearMemory,'Visible', 'on')
    if ~isnan(findstr(cd, 'Slave'))
%       do nothing          
    else
        if strcmp(get(handles.uipanel_Pauli, 'Visible'),'on')
            set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'on')
        else
            warndlg(['To enable the pushbutton ''Calculate...'', you must before ',...
              'calculate the Pauli vectors of the relative equilibrium point'])
            set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
        end
    end
    set(handles.popupmenuODE2,'Visible', 'off')
    set(handles.popupmenuODE,'Visible', 'on')
    set(handles.uipanel_GniCodes,'Visible', 'off')
    set(handles.edit_OutputStep,'Visible', 'on')
    if str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String'))
        set(handles.ComputeLFA,'String',get(handles.edit_ClearMemory,'String'))  
    end
    set(handles.LGG3_long_FMFT,'Enable', 'on')
    set(handles.LSD_long_FMFT,'Enable', 'off')    
elseif strcmp(txt, ' Global analysis: Rotated Pauli ') == 1
    set(handles.uipanel_PoincFreq_2D, 'Visible', 'off')
    set(handles.uipanel_Freq3D_LGG3, 'Visible', 'off')
    set(handles.uipanel_Freq3D_LSD, 'Visible', 'on')
    set(handles.uipanelInit, 'Visible', 'off')
    set(handles.uipanel_AA_FMFT, 'Visible', 'off')
    set(handles.uipanel_RegMethod, 'Visible', 'off')
    set(handles.uipanel_StandMethod, 'Visible', 'off')
    set(handles.uipanel_from_to, 'Visible', 'off')
    if strcmp(get(handles.LSD_long_FMFT, 'Checked'),'on')   
        set(handles.LongtimeFA,'Visible', 'on')
    else
        set(handles.LongtimeFA,'Visible', 'off')
    end
    set(handles.uipanel_ClearMemory,'Visible', 'on')
    if ~isnan(findstr(cd, 'Slave'))
%       do nothing          
    else
        if strcmp(get(handles.uipanel_Pauli, 'Visible'),'on')
            set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'on')
        else
            warndlg(['To enable the pushbutton ''Calculate...'', you must before ',...
              'calculate the Pauli vectors of the relative equilibrium point'])
            set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
        end
    end
    set(handles.popupmenuODE2,'Visible', 'off')
    set(handles.popupmenuODE,'Visible', 'on')
    set(handles.uipanel_GniCodes,'Visible', 'off')
    set(handles.edit_OutputStep,'Visible', 'on')
    if str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String'))
        set(handles.ComputeLFA,'String',get(handles.edit_ClearMemory,'String'))  
    end
    if ~isnan(findstr(cd, 'Slave'))
        set(handles.pushbutton_StartSlave_LSD, 'Visible', 'on')
    end
    set(handles.LGG3_long_FMFT,'Enable', 'off')
    set(handles.LSD_long_FMFT,'Enable', 'on')    
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Perturbation Hamiltonian
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_epsilon1_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String'))) &...
        (strcmp(get(handles.warningbox, 'Checked'),'on'))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
function edit_epsilon2_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String'))) &...
        (strcmp(get(handles.warningbox, 'Checked'),'on'))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
function edit_epsilon3_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String'))) &...
        (strcmp(get(handles.warningbox, 'Checked'),'on'))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
function edit_epsilon4_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String'))) &...
        (strcmp(get(handles.warningbox, 'Checked'),'on'))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
function edit_epsilon5_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String'))) &...
        (strcmp(get(handles.warningbox, 'Checked'),'on'))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%---------------------------------------------------------------------------
% --- Executes on selection change in popupmenuHp1.
function popupmenuHp1_Callback(hObject, eventdata, handles)

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
% --- Executes on selection change in popupmenuHp2.
function popupmenuHp2_Callback(hObject, eventdata, handles)

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
% --- Executes on selection change in popupmenuHp3.
function popupmenuHp3_Callback(hObject, eventdata, handles)

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
% --- Executes on selection change in popupmenuHp4.
function popupmenuHp4_Callback(hObject, eventdata, handles)

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%--------------------------------------------------------------------------
% --- Executes on selection change in popupmenuHp5.
function popupmenuHp5_Callback(hObject, eventdata, handles)

Disable_General
set(handles.uipanel_Pauli,'Visible','off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
set(handles.radiobutton_Pauliprime, 'Enable', 'off')
set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               Initial conditions (Cartesian)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function q1_value_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}
Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateKepler, 'Enable', 'on')

%--------------------------------------------------------------------------
function q2_value_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}
Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateKepler, 'Enable', 'on')

%--------------------------------------------------------------------
function q3_value_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}
Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateKepler, 'Enable', 'on')

%--------------------------------------------------------------------------
function p1_value_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}
Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateKepler, 'Enable', 'on')

%--------------------------------------------------------------------------
function p2_value_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}
Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateKepler, 'Enable', 'on')

%--------------------------------------------------------------------------
function p3_value_Callback(hObject, eventdata, handles)
%{
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
%}
Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateKepler, 'Enable', 'on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 Initial conditions (Keplerian)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_smaxis_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateCartesian, 'Enable', 'on')

%--------------------------------------------------------------------------
function edit_Eccentricity_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateCartesian, 'Enable', 'on')

%--------------------------------------------------------------------------
function edit_AscNode_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateCartesian, 'Enable', 'on')

%--------------------------------------------------------------------------
function edit_ArgPericenter_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateCartesian, 'Enable', 'on')

%--------------------------------------------------------------------------
function edit_Inclination_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateCartesian, 'Enable', 'on')

%--------------------------------------------------------------------------
function edit_TrueAnomaly_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

Disable_General
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'off')
set(handles.pushbutton_UpdateCartesian, 'Enable', 'on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                       Update
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_UpdateKepler.
function pushbutton_UpdateKepler_Callback(hObject, eventdata, handles)
q_vec_o(1) = str2num(get(handles.q1_value,'String'));
q_vec_o(2) = str2num(get(handles.q2_value,'String'));
q_vec_o(3) = str2num(get(handles.q3_value,'String'));
p_vec_o(1) = str2num(get(handles.p1_value,'String'));
p_vec_o(2) = str2num(get(handles.p2_value,'String'));
p_vec_o(3) = str2num(get(handles.p3_value,'String'));

Cartesian2Keplerian

set(handles.edit_smaxis,'String', num2str(sm_ax_o,'%5.10f'))
set(handles.edit_Eccentricity,'String', num2str(Ecc_o,'%5.10f'))
set(handles.edit_AscNode,'String', num2str(Omega_o,'%5.10f'))
set(handles.edit_ArgPericenter,'String', num2str(omega_o,'%5.10f'))
set(handles.edit_Inclination,'String', num2str(incl_o,'%5.10f'))
set(handles.edit_TrueAnomaly,'String', num2str(f_o,'%5.10f'))

set(hObject,'Enable','off')
set(handles.pushbutton_Integrate,'Enable','on')
set(handles.pushbutton_StandIntegrate,'Enable','on')
if (get(handles.radiobutton_no,'Value') == 1) &...
    strcmp(get(handles.uipanel_Pauli, 'Visible'),'on')
    set(handles.pushbutton_Up_Pauli, 'Enable', 'on')
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_UpdateCartesian.
function pushbutton_UpdateCartesian_Callback(hObject, eventdata, handles)
sm_ax_o = str2num(get(handles.edit_smaxis,'String'));
Ecc_o = str2num(get(handles.edit_Eccentricity,'String'));
Omega_o = str2num(get(handles.edit_AscNode,'String'));
omega_o = str2num(get(handles.edit_ArgPericenter,'String'));
incl_o = str2num(get(handles.edit_Inclination,'String'));
f_o = str2num(get(handles.edit_TrueAnomaly,'String'));

Keplerian2Cartesian

set(handles.q1_value,'String', num2str(q_vec_o(1),'%5.10f'))
set(handles.q2_value,'String', num2str(q_vec_o(2),'%5.10f'))
set(handles.q3_value,'String', num2str(q_vec_o(3),'%5.10f'))
set(handles.p1_value,'String', num2str(p_vec_o(1),'%5.10f'))
set(handles.p2_value,'String', num2str(p_vec_o(2),'%5.10f'))
set(handles.p3_value,'String', num2str(p_vec_o(3),'%5.10f'))

set(hObject,'Enable','off')
set(handles.pushbutton_Integrate,'Enable','on')
set(handles.pushbutton_StandIntegrate,'Enable','on')
if (get(handles.radiobutton_no,'Value') == 1) &...
    strcmp(get(handles.uipanel_Pauli, 'Visible'),'on')
    set(handles.pushbutton_Up_Pauli, 'Enable', 'on')
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_Up_Pauli.
function pushbutton_Up_Pauli_Callback(hObject, eventdata, handles)
clear global lambda 
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 Hp1 Hp2 Hp3 Hp4 Hp5
contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));
%--------------------------------------------------------

q_vec_o(1) = str2num(get(handles.q1_value,'String'));
q_vec_o(2) = str2num(get(handles.q2_value,'String'));
q_vec_o(3) = str2num(get(handles.q3_value,'String'));
p_vec_o(1) = str2num(get(handles.p1_value,'String'));
p_vec_o(2) = str2num(get(handles.p2_value,'String'));
p_vec_o(3) = str2num(get(handles.p3_value,'String'));
E_total = 1/2*norma(p_vec_o).^2 - 1./norma(q_vec_o)...
     + Hp(q_vec_o, p_vec_o, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5);
 
Cartesian2SD
set(handles.edit_S01,'String', num2str(S1,'%1.10f'))
set(handles.edit_S02,'String', num2str(S2,'%1.10f'))
set(handles.edit_S03,'String', num2str(S3,'%1.10f'))
set(handles.edit_D01,'String', num2str(D1,'%1.10f'))
set(handles.edit_D02,'String', num2str(D2,'%1.10f'))
set(handles.edit_D03,'String', num2str(D3,'%1.10f'))
set(handles.edit_Energy,'String', num2str(E_total,'%1.8f'))
set(handles.edit_EnergyPoincare,'String', num2str(E_total,'%1.8f'))
set(handles.edit_EnergyLGG3,'String', num2str(E_total,'%1.8f'))
set(handles.edit_EnergyLSD,'String', num2str(E_total,'%1.8f'))

set(hObject, 'Enable', 'off')

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                       ODE solver
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on selection change in popupmenuODE.
function popupmenuODE_Callback(hObject, eventdata, handles)
Disable_General
global KeplerDir
cd(KeplerDir)

contents = get(hObject,'String');
item = get(hObject,'Value');
ODE = char(contents(item));
if strcmp(ODE, 'Tom') == 1
    set(handles.uiPanel_Options, 'Visible', 'off')
    set(handles.uiPanel_TomOptions, 'Visible', 'on')
    set(handles.uipanel_RungeKutta, 'Visible', 'off')
    set(handles.radiobutton_NonPert,'Value', 1)
    set(handles.radiobutton_2D_nonpert,'Value', 1)
    set(handles.radiobutton_NonPert_LGG3,'Value', 1)
    set(handles.radiobutton_NonPert_LSD,'Value', 1)    
    set(handles.edit_block,'String', '16')
    set(handles.edit_block,'Visible', 'on')
    set(handles.text_block,'Visible', 'on')
elseif (strcmp(ODE, 'RungeKutta4') == 1) | (strcmp(ODE, 'RungeKutta5') == 1)
    set(handles.uiPanel_Options, 'Visible', 'off')
    set(handles.uipanel_RungeKutta, 'Visible', 'on')
    set(handles.uiPanel_TomOptions, 'Visible', 'off')
    set(handles.text_block,'Visible', 'off')
    set(handles.edit_block,'Visible', 'off')
    set(handles.LongtimeFA,'Visible', 'off')
    set(handles.text_IRKMeth,'Visible', 'off')
    set(handles.edit_IRKMeth,'Visible', 'off')
    set(handles.radiobutton_Pert,'Value', 1)
    set(handles.radiobutton_2D_pert,'Value', 1)
    set(handles.radiobutton_Pert_LGG3,'Value', 1)
    set(handles.radiobutton_Pert_LSD,'Value', 1)   
elseif  (strcmp(ODE, 'IRKGauss') == 1)   
    set(handles.uiPanel_Options, 'Visible', 'off')
    set(handles.uipanel_RungeKutta, 'Visible', 'on')
    set(handles.uiPanel_TomOptions, 'Visible', 'off')
    set(handles.text_IRKMeth,'Visible', 'on')
    set(handles.edit_IRKMeth,'Visible', 'on')
    set(handles.radiobutton_NonPert,'Value', 1)
    set(handles.radiobutton_2D_nonpert,'Value', 1)
    set(handles.radiobutton_NonPert_LGG3,'Value', 1)
    set(handles.radiobutton_NonPert_LSD,'Value', 1)    
    set(handles.edit_block,'String', '100')
    set(handles.edit_block,'Visible', 'on')
    set(handles.text_block,'Visible', 'on')    
else
    set(handles.uiPanel_Options, 'Visible', 'on')
    set(handles.uiPanel_TomOptions, 'Visible', 'off')
    set(handles.uipanel_RungeKutta, 'Visible', 'off')
    set(handles.radiobutton_Pert,'Value', 1)
    set(handles.radiobutton_2D_pert,'Value', 1)
    set(handles.radiobutton_Pert_LGG3,'Value', 1)
    set(handles.radiobutton_Pert_LSD,'Value', 1)   
    set(handles.edit_block,'String', '25')
    if isempty(get(handles.edit_OutputStep,'String'))
        set(handles.edit_block,'Visible', 'off')
        set(handles.text_block,'Visible', 'off')
    else
        set(handles.edit_block,'Visible', 'on')
        set(handles.text_block,'Visible', 'on')
    end
end

%--------------------------------------------------------------------------
function edit_RelTol_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_AbsTol_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_InitialStep_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_MaxStep_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_OutputStep_Callback(hObject, eventdata, handles)
if isempty(get(handles.edit_OutputStep,'String'))
    set(handles.edit_block,'Visible', 'off')
    set(handles.text_block,'Visible', 'off')
else
    set(handles.edit_block,'Visible', 'on')
    set(handles.text_block,'Visible', 'on')
end

if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end
Disable_General
clear global Ang_tot Act_tot
set(handles.pushbutton_ClearAppend,'Enable','off')

%--------------------------------------------------------------------------
function edit_met_Callback(hObject, eventdata, handles)
TOMmeth = get(handles.edit_met,'String');
if (strcmp(TOMmeth, '1') == 0) & (strcmp(TOMmeth, '2') == 0);
    errordlg('The allowed values are Method = 1, 2.','Error')
    set(handles.edit_met,'String', '1');
end

Disable_General

%--------------------------------------------------------------------------
function edit_Order_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_StepSize_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', '0.1');
    errordlg('Input must be a number.  Default value = 0.1.','Error');
end
Disable_General
%--------------------------------------------------------------------------
function edit_RelTolNewt_Callback(hObject, eventdata, handles)

Disable_General
set(handles.pushbutton_tKepler, 'Enable', 'off')

%--------------------------------------------------------------------------
function edit_Itnlmax_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))...
        & size(get(hObject, 'String'),2) ~= 0
    set(hObject, 'String', '');
    errordlg('Input must be void or a number','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_FixedStepSize_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', '0.05');
    errordlg('Input must be a number.  Default value = 0.05.','Error');
end

Disable_General

%--------------------------------------------------------------------------
function edit_IRKMeth_Callback(hObject, eventdata, handles)
IRKMeth = get(handles.edit_IRKMeth,'String');
if (strcmp(IRKMeth, '2') == 0) & (strcmp(IRKMeth, '3') == 0) &...
        (strcmp(IRKMeth, '4') == 0) & (strcmp(IRKMeth, '6') == 0);
    errordlg('The allowed values are Method = 2, 3, 4, 6, with Order = 2*Method.','Error')
    set(handles.edit_IRKMeth,'String', '6');
end

Disable_General

%--------------------------------------------------------------------------
function edit_block_Callback(hObject, eventdata, handles)
Disable_General

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               Revolution's Number
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function total_cycles_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
max = get(hObject,'String');
set(handles.edit_to,'String', max)
set(handles.edit_from,'String', '0')

Disable_General
clear global Ang_tot Act_tot
set(handles.pushbutton_clear,'Enable','off')
set(handles.pushbutton_ClearAppend,'Enable','off')
contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

%--------------------------------------------------------------------------
function edit_from_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
if str2num(get(hObject,'String')) > str2num(get(handles.total_cycles,'String'))...
      | str2num(get(hObject,'String')) > str2num(get(handles.edit_to,'String'))
   set(hObject,'String', '0')
end
clear global Ang_tot Act_tot
set(handles.pushbutton_ClearAppend,'Enable','off')

%--------------------------------------------------------------------------
function edit_to_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end
if str2num(get(handles.total_cycles,'String')) < str2num(get(hObject,'String'))...
        | str2num(get(hObject,'String')) < str2num(get(handles.edit_from,'String'))
    val = get(handles.total_cycles,'String');
    set(hObject,'String', val)
end
clear global Ang_tot Act_tot
set(handles.pushbutton_ClearAppend,'Enable','off')

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   Regularization method
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pushbutton_Integrate.
function pushbutton_Integrate_Callback(hObject, eventdata, handles)
clear global q_vec p_vec sm_ax q_vec_o p_vec_o tau_total tau_i tau_f dist
clear global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
clear global lambda step_i step_f x_vec y_vec tau tau_c W Ko

global q_vec p_vec sm_ax q_vec_o p_vec_o tau_total tau_i tau_f
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
global lambda step_i step_f x_vec y_vec tau tau_c W Ko
global perfid KeplerDir PhSpGeoDir

Disable_General
cd(KeplerDir)

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

q_vec_o(1) = str2num(get(handles.q1_value,'String'));
q_vec_o(2) = str2num(get(handles.q2_value,'String'));
q_vec_o(3) = str2num(get(handles.q3_value,'String'));
p_vec_o(1) = str2num(get(handles.p1_value,'String'));
p_vec_o(2) = str2num(get(handles.p2_value,'String'));
p_vec_o(3) = str2num(get(handles.p3_value,'String'));

tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

Integrate

clear DiffEquation

%--------------------------------------------------------------------------
% --- Executes on button press in radiobutton_Pert.
function radiobutton_Pert_Callback(hObject, eventdata, handles)
Disable_General

if (get(handles.popupmenuODE,'Value') == 3 | get(handles.popupmenuODE,'Value') == 6)
    warndlg({'If you are sure that the problem is regular, then disable';...
             '''Watch falling into singularities'' in the Window menu'})
end
    
% --- Executes on button press in radiobutton_NonPert.
function radiobutton_NonPert_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_Trajectories.
function pushbutton_Trajectories_Callback(hObject, eventdata, handles)
global q_vec p_vec tau_c W lambda
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
delta_tau = tau_f - tau_i;
if delta_tau > 100
    button = questdlg(sprintf(['In 3D, we advise against displaying more than (about) 100 cycles:\n',...
        'the visualization may be lengthy and the figure overloaded.\n',...
        '               Do you continue anyway?']),...
        'Too much cycles to display', 'No');
    if strcmp(button,'Yes')
        if get(handles.radiobutton_Pert,'Value') == 1
            Calculate_Trajectories
        elseif get(handles.radiobutton_NonPert,'Value') == 1
            Calculate_TrajectoriesNonPert
        end     
        Trajectories
    end
else
    if get(handles.radiobutton_Pert,'Value') == 1
        Calculate_Trajectories
    elseif get(handles.radiobutton_NonPert,'Value') == 1
        Calculate_TrajectoriesNonPert
    end         
    Trajectories
end

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_tauKepler.
function pushbutton_tauKepler_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec tau W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     
tau_Kepler_Parameters

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_tKepler.
function pushbutton_tKepler_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec tau W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     
t_Kepler_Parameters

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_Time.
function pushbutton_Time_Callback(hObject, eventdata, handles)
global lambda q_vec W tau tau_i tau_f tau_total tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     
Time

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_Errors.
function pushbutton_Errors_Callback(hObject, eventdata, handles)
global q_vec p_vec step_i step_f x_vec y_vec W tau tau_c
global Ko q_vec_o p_vec_o lambda
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     
Errors

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_tau_Step.
function pushbutton_tau_Step_Callback(hObject, eventdata, handles)
global q_vec p_vec tau_c W lambda
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     
figure
plot(tau)
title('False time \itvs \rmStep number','FontSize',12)
xlabel('Step number', 'FontSize',14), ylabel('\tau', 'FontSize',14)

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_UserFunction.
function pushbutton_UserFunction_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec tau W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     

q1 = q_vec(:,1);
q2 = q_vec(:,2);
q3 = q_vec(:,3);
p1 = p_vec(:,1);
p2 = p_vec(:,2);
p3 = p_vec(:,3);

global KeplerDir
cd(KeplerDir);
[filename, pathname] = uigetfile( ...
    {'*.m', 'All M-Files (*.m)'; ...
        '*.*','All Files (*.*)'}, ...
    'Choose function(s) to plot','UserFunctions/');
if isequal([filename,pathname],[0,0])
    return
else
    [pathstr, name, ext] = fileparts(filename);
    cd(pathname)
    eval(name)
    cd(KeplerDir)
end

d = size(UserFunction, 2);
for k = 1:d
    figure
    plot(tau, UserFunction(:,k))
    str = num2str(k);
    title(['User function ', str, ' \itvs \rmFalse time'],'FontSize',12)
    xlabel('\tau', 'FontSize',14), ylabel('Function', 'FontSize',14)
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Standard method
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_StandIntegrate.
function pushbutton_StandIntegrate_Callback(hObject, eventdata, handles)
clear global  epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 Hp1 Hp2 Hp3 Hp4 Hp5 t_c W
clear global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f t
clear global lambda
global  epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 Hp1 Hp2 Hp3 Hp4 Hp5 t_c W
global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f t
global perfid KeplerDir

cd(KeplerDir)
contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

q_vec_o(1) = str2num(get(handles.q1_value,'String'));
q_vec_o(2) = str2num(get(handles.q2_value,'String'));
q_vec_o(3) = str2num(get(handles.q3_value,'String'));
p_vec_o(1) = str2num(get(handles.p1_value,'String'));
p_vec_o(2) = str2num(get(handles.p2_value,'String'));
p_vec_o(3) = str2num(get(handles.p3_value,'String'));

sm_ax_o = str2num(get(handles.edit_smaxis,'String'));

tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
Disable_General

if get(handles.radiobutton_1st,'Value') == 1
    contents = get(handles.popupmenuODE,'String');
    item = get(handles.popupmenuODE,'Value');
    ODE = char(contents(item)); 
    Stand_Integrate
end

if get(handles.radiobutton_2nd,'Value') == 1
    warndlg(sprintf(['You have selected a fixed-step integrator,\n',...
    'but keep in mind that its use is not advisable with the Standard\n',...
    'Integration method, which in general requires an adaptative step.\n',...
    'Be sure that the problem is very regular and the eccentricity small.']),...
    'Fixed-step integrator');
    contents = get(handles.popupmenuODE2,'String');
    item = get(handles.popupmenuODE2,'Value');
    ODE2 = char(contents(item));
    ODE = ODE2;
    Stand_2ndOrd_Integrate
end

if (((get(handles.radiobutton_1st,'Value') == 1)...
        | ((get(handles.radiobutton_2nd,'Value') == 1)...
        & (dHp_p1 == 0 & dHp_p2 == 0 & dHp_p3 == 0))))

    set(handles.pushbutton_StandTrajectories, 'Enable', 'on')
    set(handles.pushbutton_KeplerParameters, 'Enable', 'on')
    set(handles.pushbutton_Error, 'Enable', 'on')
    set(handles.pushbutton_t_Step, 'Enable', 'on')
    set(handles.pushbutton_Stand_UserFunction, 'Enable', 'on')
end

clear StandDiffEq
clear Stand2ndOrdDiffEq

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in radiobutton_1st.
function radiobutton_1st_Callback(hObject, eventdata, handles)
set(handles.popupmenuODE2,'Visible', 'off')
set(handles.popupmenuODE,'Visible', 'on','Value',1)
set(handles.radiobutton_Pert,'Value',1)
set(handles.radiobutton_NonPert,'Value',0)
set(handles.text_block,'Visible', 'on')
set(handles.edit_block,'Visible', 'on','String','25')
set(handles.uipanel_GniCodes,'Visible', 'off')
set(handles.uiPanel_TomOptions,'Visible', 'off')
set(handles.uiPanel_Options,'Visible', 'on')
set(handles.uipanel_RungeKutta,'Visible', 'off')
set(handles.edit_OutputStep,'Visible', 'on')

set(handles.uipanel_RegMethod,'Visible', 'on')
set(handles.pushbutton_Integrate, 'Enable', 'on')
set(handles.pushbutton_StandIntegrate, 'Enable', 'on')

Disable_General

% --- Executes on button press in radiobutton_2nd.
function radiobutton_2nd_Callback(hObject, eventdata, handles)
set(handles.popupmenuODE2,'Visible', 'on')
set(handles.popupmenuODE,'Visible', 'off')
set(handles.uipanel_GniCodes,'Visible', 'on')
set(handles.uiPanel_TomOptions,'Visible', 'off')
set(handles.uiPanel_Options,'Visible', 'off')
set(handles.uipanel_RungeKutta,'Visible', 'off')
set(handles.uipanel_RegMethod,'Visible', 'off')
set(handles.text_block,'Visible', 'off')
set(handles.edit_block,'Visible', 'off')
set(handles.pushbutton_Integrate, 'Enable', 'off')
set(handles.pushbutton_StandIntegrate, 'Enable', 'on')

Disable_General

% --- Executes on selection change in popupmenuODE2.
function popupmenuODE2_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StandTrajectories, 'Enable', 'off')
set(handles.pushbutton_KeplerParameters, 'Enable', 'off')
set(handles.pushbutton_Error, 'Enable', 'off')
set(handles.pushbutton_t_Step, 'Enable', 'off')
set(handles.pushbutton_Stand_UserFunction, 'Enable', 'off')

function edit_StepSize2_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', '0.01');
    errordlg('Input must be a number. Default value = 0.01.','Error');
end
set(handles.pushbutton_StandTrajectories, 'Enable', 'off')
set(handles.pushbutton_KeplerParameters, 'Enable', 'off')
set(handles.pushbutton_Error, 'Enable', 'off')
set(handles.pushbutton_t_Step, 'Enable', 'off')
set(handles.pushbutton_Stand_UserFunction, 'Enable', 'off')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_StandTrajectories.
function pushbutton_StandTrajectories_Callback(hObject, eventdata, handles)
global q_vec p_vec tau_c W t_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
delta_tau = tau_f - tau_i;
if delta_tau > 100
    button = questdlg(sprintf(['In 3D, we advise against displaying more than (about) 100 cycles:\n',...
        'the visualization way be lengthy and the figure overloaded.\n',...
        '               Do you continue anyway?']),...
        'Too much cycles to display', 'No');
    if strcmp(button,'Yes')
        Stand_Calculate_Trajectories
        Stand_Trajectories
    end
else
    Stand_Calculate_Trajectories
    Stand_Trajectories
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_KeplerParameters.
function pushbutton_KeplerParameters_Callback(hObject, eventdata, handles)
global q_vec p_vec W t_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

Stand_Calculate_Trajectories
Stand_Kepler_Parameters

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_Error.
function pushbutton_Error_Callback(hObject, eventdata, handles)
clear global lambda
global q_vec p_vec q_vec_o p_vec_o t W t_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
Stand_Calculate_Trajectories
ErrorHstand

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_t_Step.
function pushbutton_t_Step_Callback(hObject, eventdata, handles)
global q_vec p_vec tau_c W t_c sm_ax_o
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

Stand_Calculate_Trajectories
figure
plot(t)
title('Time \itvs \rmStep number','FontSize',12)
xlabel('Step number', 'FontSize',14), ylabel('\itt', 'FontSize',14)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_Stand_UserFunction.
function pushbutton_Stand_UserFunction_Callback(hObject, eventdata, handles)
global q_vec p_vec t W t_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
Stand_Calculate_Trajectories
q1 = q_vec(:,1);
q2 = q_vec(:,2);
q3 = q_vec(:,3);
p1 = p_vec(:,1);
p2 = p_vec(:,2);
p3 = p_vec(:,3);

global KeplerDir
cd(KeplerDir);
[filename, pathname] = uigetfile( ...
    {'*.m', 'All M-Files (*.m)'; ...
        '*.*','All Files (*.*)'}, ...
    'Choose function(s) to plot','UserFunctions/');
if isequal([filename,pathname],[0,0])
    return
else
    [pathstr, name, ext] = fileparts(filename);
    cd(pathname)
    eval(name)
    cd(KeplerDir)
end

d = size(UserFunction, 2);
for k = 1:d
    figure
    plot(t, UserFunction(:,k))
    str = num2str(k);
    title(['User function ', str, ' \itvs \rmFalse time'],'FontSize',12)
    xlabel('\itt', 'FontSize',14), ylabel('Function', 'FontSize',14)
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Action-Angle variables and (Time-)frequency analysis on KAM tori
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Pauli vectors
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%--------------------------------------------------------------------------
function edit_S01_Callback(hObject, eventdata, handles)
NormalizeS
if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_S02_Callback(hObject, eventdata, handles)
NormalizeS
if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_S03_Callback(hObject, eventdata, handles)
NormalizeS
if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_D01_Callback(hObject, eventdata, handles)
NormalizeD
if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_D02_Callback(hObject, eventdata, handles)
NormalizeD
if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_D03_Callback(hObject, eventdata, handles)
NormalizeD
if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_Energy_Callback(hObject, eventdata, handles)

E_tot_str = get(handles.edit_Energy,'String');
set(handles.edit_EnergyPoincare,'String', E_tot_str);
set(handles.edit_EnergyLGG3,'String', E_tot_str);
set(handles.edit_EnergyLSD,'String', E_tot_str);

if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_Pauli.
function pushbutton_Pauli_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec W tau tau_i tau_f tau_total tau_c S_vec_o D_vec_o
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 Hp1 Hp2 Hp3 Hp4 Hp5
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_no,'Value') == 1
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
end
set(handles.pushbutton_Pauliprime, 'Enable', 'on')
set(handles.pushbutton_AA_Delaunayprime, 'Enable', 'on')
set(handles.pushbutton_AA_Pauliprime, 'Enable', 'on')
if strcmp(get(handles.uipanel_Pauli, 'Visible'),'off')
    set(handles.radiobutton_no,'Value',1)
    set(handles.radiobutton_yes,'Value',0)
    set(handles.pushbutton_UpdateInit, 'Enable', 'on')
    set(handles.uipanel_Pauli, 'Visible', 'on')
 %   set(handles.radiobutton_Delaunayprime, 'Enable', 'on', 'Value',0)
 %   set(handles.radiobutton_Pauliprime, 'Enable', 'on', 'Value',0)
     set(handles.radiobutton_Delaunayprime, 'Enable', 'on')
     set(handles.radiobutton_Pauliprime, 'Enable', 'on')

end

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end
%q_vec = x_vec;   
%p_vec = y_vec;
tau_SD

if get(handles.radiobutton_no,'Value') == 1
    set(handles.edit_S01,'String', num2str(S_vec_o(1)))
    set(handles.edit_S02,'String', num2str(S_vec_o(2)))
    set(handles.edit_S03,'String', num2str(S_vec_o(3)))
    set(handles.edit_D01,'String', num2str(D_vec_o(1)))
    set(handles.edit_D02,'String', num2str(D_vec_o(2)))
    set(handles.edit_D03,'String', num2str(D_vec_o(3)))
    clear global lambda
    Energy = 1/2*norma(p_vec(1,:))^2 - 1./norma(q_vec(1,:)) + Hp(q_vec(1,:), p_vec(1,:),...
                   epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5);
    global lambda
    lambda = 1/sqrt(-2*Energy);
    TotE = num2str(Energy(1));
    set(handles.edit_Energy,'String', TotE)
    set(handles.edit_EnergyPoincare,'String', TotE)
    set(handles.edit_EnergyLGG3,'String', TotE)
    set(handles.edit_EnergyLSD,'String', TotE)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_Pauliprime.
function pushbutton_Pauliprime_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec S_vec_o D_vec_o tau Sprime_vec Dprime_vec
global W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

S_vec_o(1) = str2num(get(handles.edit_S01,'String'));
S_vec_o(2) = str2num(get(handles.edit_S02,'String'));
S_vec_o(3) = str2num(get(handles.edit_S03,'String'));
D_vec_o(1) = str2num(get(handles.edit_D01,'String'));
D_vec_o(2) = str2num(get(handles.edit_D02,'String'));
D_vec_o(3) = str2num(get(handles.edit_D03,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end

tau_SDprime

set(handles.pushbutton_FFT, 'Enable', 'on')
set(handles.pushbutton_FMFT, 'Enable', 'on')
set(handles.pushbutton_wavelet, 'Enable', 'on')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_UpdateInit.
function pushbutton_UpdateInit_Callback(hObject, eventdata, handles)
clear global lambda
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 Hp1 Hp2 Hp3 Hp4 Hp5

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));


S_vec_o(1) = str2num(get(handles.edit_S01,'String'));
S_vec_o(2) = str2num(get(handles.edit_S02,'String'));
S_vec_o(3) = str2num(get(handles.edit_S03,'String'));
D_vec_o(1) = str2num(get(handles.edit_D01,'String'));
D_vec_o(2) = str2num(get(handles.edit_D02,'String'));
D_vec_o(3) = str2num(get(handles.edit_D03,'String'));

[q_vec_o, p_vec_o] = SD2Cartesian(S_vec_o/2, D_vec_o/2);

%-------------------------------------------------------------------------------
E_tot = str2num(get(handles.edit_Energy,'String'));
lambda_tot = 1/sqrt(-2*E_tot);
lambd = lambda_tot + 1;
lambda = 1.0;

kk = 0;
while abs(lambd - lambda_tot) > 1e-02
    if kk > 50
        break
    end
    lambd = 1/sqrt(-2*(1/2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')...
        + Hp(q_vec_o, p_vec_o, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5)));
        
    if ~isreal(lambd)
        break
    end
            
    q_vec_o = lambda_tot^2*q_vec_o/lambd^2;
    p_vec_o = p_vec_o*lambd/lambda_tot;
    kk = kk + 1;
end
        
if (~isreal(lambd) | isnan(lambd))
     [q_vec_o, p_vec_o] = SD2Cartesian(S_vec_o/2, D_vec_o/2);
end
        
f = @(z)1/sqrt(-2*(1/2*z^2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')*z^2 ...
       + Hp(q_vec_o/z^2, p_vec_o*z, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5))) - lambda_tot;
opts = optimset('Display','off');

try
    a = fzero(f,1,opts);
catch
    warndlg(sprintf(['With the selected value of Total Energy I am not able to find the initial conditions.']))
    return
end

if isnan(a)
    warndlg(sprintf(['With the selected value of Total Energy I am not able to find the initial conditions.']))
    return
end                  
q_vec_o = q_vec_o/a^2;
p_vec_o = p_vec_o*a;
lambda = lambda_tot;
%---------------------------------------------------------------------

set(handles.q1_value,'String', num2str(q_vec_o(1),'%5.10f'))
set(handles.q2_value,'String', num2str(q_vec_o(2),'%5.10f'))
set(handles.q3_value,'String', num2str(q_vec_o(3),'%5.10f'))
set(handles.p1_value,'String', num2str(p_vec_o(1),'%5.10f'))
set(handles.p2_value,'String', num2str(p_vec_o(2),'%5.10f'))
set(handles.p3_value,'String', num2str(p_vec_o(3),'%5.10f'))

Cartesian2Keplerian

set(handles.edit_smaxis,'String', num2str(sm_ax_o,'%5.10f'))
set(handles.edit_Eccentricity,'String', num2str(Ecc_o,'%5.10f'))
set(handles.edit_AscNode,'String', num2str(Omega_o,'%5.10f'))
set(handles.edit_ArgPericenter,'String', num2str(omega_o,'%5.10f'))
set(handles.edit_Inclination,'String', num2str(incl_o,'%5.10f'))
set(handles.edit_TrueAnomaly,'String', num2str(f_o,'%5.10f'))

Disable_General

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in radiobutton_yes.
function radiobutton_yes_Callback(hObject, eventdata, handles)
set(handles.pushbutton_UpdateInit, 'Enable', 'off')
set(handles.pushbutton_Up_Pauli, 'Enable', 'off')

% --- Executes on button press in radiobutton_no.
function radiobutton_no_Callback(hObject, eventdata, handles)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Action-Angle
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pushbutton_AA_Delaunay.
function pushbutton_AA_Delaunay_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec W tau_i tau_f tau_total tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if strcmp(get(handles.pushbutton_Trajectories, 'Enable'),'on')
    if get(handles.radiobutton_Pert,'Value') == 1
        Calculate_Trajectories
    elseif get(handles.radiobutton_NonPert,'Value') == 1
        Calculate_TrajectoriesNonPert
    end     
end
AA_Delaunay

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_AA_Delaunayprime.
function pushbutton_AA_Delaunayprime_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec W tau tau_i tau_f tau_total tau_c S_vec_o D_vec_o
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     

%%%%%%%%%%%%%%%%%%%%%
qp2SD
SD2SpDp
%%%%%%%%%%%%%%%%%%%%%
qp2uv  
%%%%%%%%%%%%%%%%%%%%%  
SoDo2uRvR
%%%%%%%%%%%%%%%%%%%%%
AA_Delaunayprime
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_AA_Pauli.
function pushbutton_AA_Pauli_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec W tau tau_i tau_f tau_total tau_c S_vec_o D_vec_o
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     
AA_Pauli

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_AA_Pauliprime.
function pushbutton_AA_Pauliprime_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec W tau tau_i tau_f tau_total tau_c S_vec_o D_vec_o
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end

%%%%%%%%%%%%%%%%%%%%%
qp2SD
SD2SpDp
%%%%%%%%%%%%%%%%%%%%%
qp2uv  
%%%%%%%%%%%%%%%%%%%%%  
SoDo2uRvR
%%%%%%%%%%%%%%%%%%%%%
AA_Pauliprime
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_AA_User.
function pushbutton_AA_User_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec W tau tau_i tau_f tau_total tau_c S_vec_o D_vec_o
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end     

global KeplerDir
cd(KeplerDir);
[filename, pathname] = uigetfile( ...
    {'*.m', 'All M-Files (*.m)'; ...
        '*.*','All Files (*.*)'}, ...
    'Choose Action-Angle file','UserFunctions/UserActionAngle/');
if isequal([filename,pathname],[0,0])
    return
else
    [pathstr, name, ext] = fileparts(filename);
    cd(pathname)
    eval(name)
    cd(KeplerDir)
end

figure
polar(pi/180*Angl, Action,'.')
title({'Action \itvs \rmangle'})
figure
if strcmp(get(handles.LargeMS, 'Checked'),'on')
    MarkSize = 6;
else
    MarkSize = 4;
end
plot(Angl, Action,'.','MarkerSize',MarkSize)
if strcmp(get(handles.no_degree, 'Checked'),'off')
    Degree_x
end
title({'Action \itvs \rmangle (deg)'})

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     (Time-)Frequency-analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%% FFT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_FFT.
function pushbutton_FFT_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec tau Sprime_vec Dprime_vec

if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if OutStep
        freq_max = 2*pi/OutStep;
    else
        warndlg(['For a correct FFT the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.01). Please, redo ''Integrate''.'])
        set(handles.edit_OutputStep,'String', num2str(0.01));
        set(handles.edit_block,'Visible', 'on')
        set(handles.text_block,'Visible', 'on')
        set(handles.pushbutton_FFT, 'Enable', 'off')
        set(handles.pushbutton_FMFT, 'Enable', 'off')
        set(handles.pushbutton_wavelet, 'Enable', 'off')
        return
    end
end

if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    if StepSize
        freq_max = 2*pi/StepSize;
    else
        StepSize = 0.04;
        freq_max = 2*pi/StepSize;
    end
end
%-------------------------------------------------------------------------
global W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end
%--------------------------------------------------------------------------
if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    freq_max = 2*pi/StepSize;
end

if get(handles.radiobutton_Delaunay,'Value') == 1
    DelaunayforFFT
end

if get(handles.radiobutton_Delaunayprime,'Value') == 1
    DelaunayprimeforFFT
end

if get(handles.radiobutton_Pauli,'Value') == 1
    PauliforFFT
end

if get(handles.radiobutton_Pauliprime,'Value') == 1
    PauliprimeforFFT
end

if get(handles.radiobutton_User,'Value') == 1
    UserforFFT
end

% --- Executes on button press in check_log.
function check_log_Callback(hObject, eventdata, handles)

%%%%%%%%%%%%%%%%%%%%%%%% FMFT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in pushbutton_FMFT.
function pushbutton_FMFT_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec tau Sprime_vec Dprime_vec S_vec_o D_vec_o
global KeplerDir PhSpGeoDir

cd(KeplerDir)
%-------------------------------------------------------------------------
global W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));

if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end
%--------------------------------------------------------------------------
if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if OutStep
        data_sep = num2str(2*pi*100000*OutStep);
        if strcmp(get(handles.warningbox, 'Checked'),'on')
            if isdeployed
                 hhh = helpdlg(sprintf(['Please wait, KEPLER is calculating. \n',...
                    'When this box will automatically shut down, you will find, in the FMFT\n'...
                    'folder, some text file(s) containing the frequencies on KAM tori.']),...
                    'Frequency Analysis');           
            else
                hhh = helpdlg(sprintf(['Please wait, KEPLER is calculating. \n',...
                    'When this box will automatically shut down, you will find, in the\n'...
                    'MATLAB editor, some text file(s) containing the frequencies on KAM tori.']),...
                    'Frequency Analysis');
            end
        end    
    else
        warndlg(['For a correct Windowed FFT the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.01). Please, redo ''Integrate''.'])
        set(handles.edit_OutputStep,'String', num2str(0.01));
        set(handles.edit_block,'Visible', 'on')
        set(handles.text_block,'Visible', 'on')        
        set(handles.pushbutton_FFT, 'Enable', 'off')
        set(handles.pushbutton_FMFT, 'Enable', 'off')
        set(handles.pushbutton_wavelet, 'Enable', 'off')
        return
    end
end

if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    data_sep = num2str(2*pi*100000*StepSize);
    if strcmp(get(handles.warningbox, 'Checked'),'on')
        if isdeployed
             hhh = helpdlg(sprintf(['Please wait, KEPLER is calculating. \n',...
                'When this box will automatically shut down, you will find, in the FMFT\n'...
                'folder, some text file(s) containing the frequencies on KAM tori.']),...
                'Frequency Analysis');           
        else
            hhh = helpdlg(sprintf(['Please wait, KEPLER is calculating. \n',...
                'When this box will automatically shut down, you will find, in the\n'...
                'MATLAB editor, some text file(s) containing the frequencies on KAM tori.']),...
                'Frequency Analysis');
        end
    end      
end

if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    if StepSize
        data_sep = num2str(2*pi*100000*StepSize);
    else
        data_sep = num2str(2*pi*100000*0.04);
    end
    if strcmp(get(handles.warningbox, 'Checked'),'on')
        if isdeployed
            hhh = helpdlg(sprintf(['Please wait, KEPLER is calculating. \n',...
                'When this box will automatically shut down, you will find, in the FMFT\n'...
                'folder, some text file(s) containing the frequencies on KAM tori.']),...
                'Frequency Analysis');           
        else
            hhh = helpdlg(sprintf(['Please wait, KEPLER is calculating. \n',...
                'When this box will automatically shut down, you will find, in the\n'...
                'MATLAB editor, some text file(s) containing the frequencies on KAM tori.']),...
                'Frequency Analysis');
        end
    end    
end

min_f = num2str(1000*str2num(get(handles.edit_fromfreq,'String')),'%6.12f');
max_f = num2str(1000*str2num(get(handles.edit_tofreq,'String')),'%6.12f');    
flag_FMFT = num2str(get(handles.popupmenu_FMFT_flag,'Value'));    
nfreq = get(handles.edit_nfreq,'String');    
d = size(q_vec(:,1),1);    
ndata = num2str(2^(floor(log2(d))));    
    
if get(handles.radiobutton_Delaunay,'Value') == 1    
    DelaunayforFMFT    
    KeplerDir = cd;    
    cd([KeplerDir, '/FMFT'])    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputL.txt',' ','>FMFT_of_L.txt'];    
    eval(cmd_string)    
    delete inputL.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputG.txt',' ','>FMFT_of_G.txt'];    
    eval(cmd_string)    
    delete inputG.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputG3.txt',' ','>FMFT_of_G3.txt'];    
    eval(cmd_string)    
    delete inputG3.txt
    
    [Freq  Amp Phase] = textread('FMFT_of_L.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for \itL')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_G.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for \itG')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_G3.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for \itG_3')    
    xlabel('Frequency \times 1000', 'FontSize',10)
    
    fid = fopen(['FMFT_of_L.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for L\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_G.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for G\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_G3.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for G3\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);
    
    if isdeployed      
        % do nothing
    else
        edit FMFT_of_L.txt FMFT_of_G.txt FMFT_of_G3.txt
    end
    
    cd(KeplerDir)    
    close(hhh)    
end

if get(handles.radiobutton_Delaunayprime,'Value') == 1
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    qp2SD
    SD2SpDp
    %%%%%%%%%%%%%%%%%%%%%
    qp2uv  
    %%%%%%%%%%%%%%%%%%%%%  
    SoDo2uRvR
    %%%%%%%%%%%%%%%%%%%%%
    DelaunayprimeforFMFT_noRes
    %%%%%%%%%%%%%%%%%%%%%
    KeplerDir = cd;    
    cd([KeplerDir, '/FMFT'])    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputL.txt',' ','>FMFT_of_Lprime.txt'];    
    eval(cmd_string)    
    delete inputL.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputG.txt',' ','>FMFT_of_Gprime.txt'];    
    eval(cmd_string)    
    delete inputG.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputG3.txt',' ','>FMFT_of_G3prime.txt'];    
    eval(cmd_string)    
    delete inputG3.txt
    
    [Freq  Amp Phase] = textread('FMFT_of_Lprime.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for "rotated" \itL')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_Gprime.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for "rotated" \itG')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_G3prime.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for "rotated" \itG_3')    
    xlabel('Frequency \times 1000', 'FontSize',10)    
    
    fid = fopen(['FMFT_of_Lprime.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for "rotated" L\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_Gprime.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for "rotated" G\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_G3prime.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for "rotated" G3\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);    

    if isdeployed
        % do nothing
    else    
        edit FMFT_of_Lprime.txt FMFT_of_Gprime.txt FMFT_of_G3prime.txt
    end
    
    cd(KeplerDir)    
    close(hhh)
end
    
if get(handles.radiobutton_Pauli,'Value') == 1    
    PauliforFMFT    
    KeplerDir = cd;    
    cd([KeplerDir, '/FMFT'])    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputL.txt',' ','>FMFT_of_LPauli.txt'];    
    eval(cmd_string)    
    delete inputL.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputS.txt',' ','>FMFT_of_S.txt'];    
    eval(cmd_string)    
    delete inputS.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputD.txt',' ','>FMFT_of_D.txt'];    
    eval(cmd_string)    
    delete inputD.txt
    
    [Freq  Amp Phase] = textread('FMFT_of_LPauli.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for \itL_P')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_S.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for \itS')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_D.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for \itD')    
    xlabel('Frequency \times 1000', 'FontSize',10)    
     
    fid = fopen(['FMFT_of_LPauli.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for LPauli\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_S.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for S\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_D.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for D\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    if isdeployed
        % do nothing
    else    
        edit FMFT_of_LPauli.txt FMFT_of_S.txt FMFT_of_D.txt
    end
    
    cd(KeplerDir)    
    close(hhh)    
end    
    
if get(handles.radiobutton_Pauliprime,'Value') == 1
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    qp2SD
    SD2SpDp
    %%%%%%%%%%%%%%%%%%%%%
    qp2uv  
    %%%%%%%%%%%%%%%%%%%%%  
    SoDo2uRvR
    %%%%%%%%%%%%%%%%%%%%%
    PauliprimeforFMFT_noRes
    %%%%%%%%%%%%%%%%%%%%%
    KeplerDir = cd;    
    cd([KeplerDir, '/FMFT'])    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputL.txt',' ','>FMFT_of_LPauliprime.txt'];    
    eval(cmd_string)    
    delete inputL.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputS.txt',' ','>FMFT_of_Sprime.txt'];    
    eval(cmd_string)    
    delete inputS.txt    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
          data_sep,' ',ndata,' ','<inputD.txt',' ','>FMFT_of_Dprime.txt'];    
    eval(cmd_string)    
    delete inputD.txt
    
    [Freq  Amp Phase] = textread('FMFT_of_LPauliprime.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for "rotated" \itL_P')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_Sprime.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for "rotated" \itS')    
    xlabel('Frequency \times 1000', 'FontSize',10)

    [Freq  Amp Phase] = textread('FMFT_of_Dprime.txt', '%f %f %f', 'headerlines', 4);
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title('FMFT for "rotated" \itD')    
    xlabel('Frequency \times 1000', 'FontSize',10)    
    
    fid = fopen(['FMFT_of_LPauliprime.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for "rotated" LPauli\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_Sprime.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for "rotated" S\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    fid = fopen(['FMFT_of_Dprime.txt'], 'a');
    fprintf(fid,'    \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for "rotated" D\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);    

    if isdeployed
        % do nothing
    else
        edit FMFT_of_LPauliprime.txt FMFT_of_Sprime.txt FMFT_of_Dprime.txt
    end
 
    cd(KeplerDir)    
    close(hhh)   
end        
    
    
if get(handles.radiobutton_User,'Value') == 1    
    UserforFMFT    
    KeplerDir = cd;    
    cd([KeplerDir, '/FMFT'])
    if exist('FMFT/inputUser.txt')
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...    
              data_sep,' ',ndata,' ','<inputUser.txt',' ','>FMFT_of_User.txt'];    
        eval(cmd_string) 
        delete inputUser.txt
        
        [Freq  Amp Phase] = textread('FMFT_of_User.txt', '%f %f %f', 'headerlines', 4);
        figure
        bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
        title('FMFT for User')    
        xlabel('Frequency \times 1000', 'FontSize',10)        
        
        fid = fopen(['FMFT_of_User.txt'], 'a');
        fprintf(fid,'    \n');
        fprintf(fid,'**************************************************************\n');
        fprintf(fid, ['Frequency analysis for User\n']);
        fprintf(fid,'**************************************************************\n');
        fclose(fid);        

        if isdeployed
            % do nothing
        else
            edit FMFT_of_User.txt
        end
    end
    cd(KeplerDir)    
    close(hhh)    
end

if isdeployed
    % do nothing
else
    delete FMFT/*.txt
end

function edit_nfreq_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

function edit_fromfreq_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

function edit_tofreq_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject, 'String')))
    set(hObject, 'String', 0);
    errordlg('Input must be a number','Error');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%% Wavelet %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_wavelet.
function pushbutton_wavelet_Callback(hObject, eventdata, handles)
global lambda q_vec p_vec tau Sprime_vec Dprime_vec S_vec_o D_vec_o
global min_freq max_freq eta sigma2 fourier_factor

min_freq = str2num(get(handles.edit_min_freq,'String'));
max_freq = str2num(get(handles.edit_max_freq,'String'));
eta = 1;
sigma2 = (2*pi*str2num(get(handles.edit_Variance,'String')))^2;
fourier_factor = 2/(eta + sqrt(2/sigma2 + eta^2));

if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if OutStep
        h = helpdlg(sprintf(['Please wait, KEPLER is calculating.']),...
        'Wavelet transform');
    else
        warndlg(['For a correct Wavelet Transform the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.05). Please, redo ''Integrate''.'])
        set(handles.edit_OutputStep,'String', num2str(0.05));
        set(handles.edit_block,'Visible', 'on')
        set(handles.text_block,'Visible', 'on')        
        set(handles.pushbutton_FFT, 'Enable', 'off')
        set(handles.pushbutton_FMFT, 'Enable', 'off')
        set(handles.pushbutton_wavelet, 'Enable', 'off')
        return
    end
elseif strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    OutStep = str2num(get(handles.edit_FixedStepSize, 'String'));
    h = helpdlg(sprintf(['Please wait, KEPLER is calculating.']),...
        'Wavelet transform');
elseif strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    OutStep = str2num(get(handles.edit_StepSize, 'String'));
    h = helpdlg(sprintf(['Please wait, KEPLER is calculating.']),...
        'Wavelet transform');    
end

%-------------------------------------------------------------------------
global W tau_c
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = str2num(get(handles.edit_from,'String'));
tau_f = str2num(get(handles.edit_to,'String'));
if get(handles.radiobutton_Pert,'Value') == 1
    Calculate_Trajectories
elseif get(handles.radiobutton_NonPert,'Value') == 1
    Calculate_TrajectoriesNonPert
end
%--------------------------------------------------------------------------

if get(handles.radiobutton_Delaunay,'Value') == 1
    DelaunayforWT
end

if get(handles.radiobutton_Delaunayprime,'Value') == 1
    DelaunayprimeforWT
end

if get(handles.radiobutton_Pauli,'Value') == 1
    PauliforWT
end

if get(handles.radiobutton_Pauliprime,'Value') == 1
    PauliprimeforWT
end

if get(handles.radiobutton_User,'Value') == 1
    UserforWT
end

if ~exist('signal')
    close(h)
    return
end

[wt, Frequency] = wavelet_transf(signal, OutStep);
spectrum = (abs(wt)).^2;
if spectrum < 1000*eps
    spectrum = 1000*eps;
end
close(h)

figure
colormap(gray)
contour(tau, Frequency, spectrum)
xlabel('Revolution number', 'FontSize',12), ylabel('Frequency \times 1000', 'FontSize',12)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in edit_min_freq.
function edit_min_freq_Callback(hObject, eventdata, handles)
if str2num(get(handles.edit_min_freq,'String')) <= 0
    warndlg('The frequencies must be strictly positive. Please, take the absolute value.')
    return
end

% --- Executes on button press in edit_max_freq.
function edit_max_freq_Callback(hObject, eventdata, handles)
if str2num(get(handles.edit_max_freq,'String'))<= 0
    warndlg('The frequencies must be strictly positive. Please, take the absolute value.')
    return
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in radiobutton_Delaunay.
function radiobutton_Delaunay_Callback(hObject, eventdata, handles)

% --- Executes on button press in radiobutton_Delaunayprime.
function radiobutton_Delaunayprime_Callback(hObject, eventdata, handles)

% --- Executes on button press in radiobutton_Pauli.
function radiobutton_Pauli_Callback(hObject, eventdata, handles)

% --- Executes on button press in radiobutton_Pauliprime.
function radiobutton_Pauliprime_Callback(hObject, eventdata, handles)

% --- Executes on button press in radiobutton_User.
function radiobutton_User_Callback(hObject, eventdata, handles)

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 PANEL:  Global analysis: Poincar section
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on button press in radiobutton_2D_system.
function radiobutton_2D_system_Callback(hObject, eventdata, handles)
%set(handles.edit_2D_G3, 'Enable', 'off')
set(handles.panelTrueNorm, 'Visible', 'off')
set(handles.edit_2D_G3, 'Visible', 'off')

% --- Executes on button press in radiobutton_3D_symmetry.
function radiobutton_3D_symmetry_Callback(hObject, eventdata, handles)
set(handles.panelTrueNorm, 'Visible', 'on')
set(handles.edit_2D_G3, 'Visible', 'on')

function edit_2D_step_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'String'), '0') == 1
    set(handles.edit_2D_init, 'Enable', 'off')
end
if strcmp(get(hObject,'String'), '0') == 0
    set(handles.edit_2D_init, 'Enable', 'on')
end

function edit_2D_G3_Callback(hObject, eventdata, handles)
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

function edit_EnergyPoincare_Callback(hObject, eventdata, handles)

E_tot_str = get(handles.edit_EnergyPoincare,'String');
set(handles.edit_Energy,'String', E_tot_str);
set(handles.edit_EnergyLGG3,'String', E_tot_str);
set(handles.edit_EnergyLSD,'String', E_tot_str);
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

function pushbutton_clear_Callback(hObject, eventdata, handles)
clear global Ang_tot Act_tot
set(handles.pushbutton_clear, 'Enable', 'off')

function checkbox_2D_freq_Callback(hObject, eventdata, handles)
if get(handles.checkbox_2D_freq, 'Value') == 1
    set(handles.maxLfreq_2D, 'Enable', 'on')
    set(handles.minLfreq_2D, 'Enable', 'on')
    set(handles.maxGfreq_2D, 'Enable', 'on')
    set(handles.minGfreq_2D, 'Enable', 'on')
else
    set(handles.maxLfreq_2D, 'Enable', 'off')
    set(handles.minLfreq_2D, 'Enable', 'off')
    set(handles.maxGfreq_2D, 'Enable', 'off')
    set(handles.minGfreq_2D, 'Enable', 'off')    
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_CalcPlot_Poincare.
function pushbutton_CalcPlot_Poincare_Callback(hObject, eventdata, handles)
clear global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
clear global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
clear global lambda step_i step_f x_vec y_vec tau tau_c W Ko

global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
global lambda step_i step_f x_vec y_vec tau tau_c W Ko
global perfid KeplerDir

cd(KeplerDir)
cd ..
cd ..
PhSpGeoDir = cd;
cd(KeplerDir)

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
if ((strcmp(ODE, 'Odex') == 1) & strcmp(get(handles.singularity, 'Checked'),'on'))
   warndlg({'When using Odex, the ''Watch falling into singularities'' in Window menu must be disabled.';'Be sure that the problem is regular.'})
   return
end

Disable_General

cd(KeplerDir)
contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

sm_ax_o =  1; 
Omega_o =  0; 
omega_o =  str2num(get(handles.edit_2D_omega,'String')); 
f_o =      0; 
G3_o =     str2num(get(handles.edit_2D_G3,'String'));
G_ofinal =  str2num(get(handles.edit_2D_final,'String'));
G_oinit = str2num(get(handles.edit_2D_init,'String'));
steps_2D = str2num(get(handles.edit_2D_step,'String'));
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = 0;
tau_f = tau_total;

if (G3_o >= G_ofinal) & (get(handles.radiobutton_3D_symmetry,'Value') == 1) & (get(handles.NormG3,'Value') == 1)
    warndlg(['The normalized ''G3'' value must be smaller ',...
          'than the normalized ''Min angular momentum'' value'])
    return
end

E_tot = str2num(get(handles.edit_EnergyPoincare,'String'));
lambda_tot = 1/sqrt(-2*E_tot);
lambda = lambda_tot;

if (G3_o >= G_ofinal*lambda) & (get(handles.radiobutton_3D_symmetry,'Value') == 1) & (get(handles.TrueG3,'Value') == 1)
    warndlg(['The true ''G3'' value must be smaller ',...
          'than the true ''Min angular momentum'' value'])
    return
end

if get(handles.checkbox_2D_Poinc,'Value') == 1
    PoincareMapG
end

if get(handles.checkbox_2D_freq,'Value') == 1
    %--------------------------------------------------------------
    if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
        OutStep = str2num(get(handles.edit_OutputStep, 'String'));
        if OutStep
        else
            warndlg(['For a correct Windowed FFT the integration MUST be performed ',...
              'with a constant Output Step (default value: 0.01). Please, redo ''Calculate and plot''.'])
            set(handles.edit_OutputStep,'String', num2str(0.01));
            return
        end
    end

    if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
        StepSize = str2num(get(handles.edit_StepSize,'String'));
        if StepSize
        OutStep = StepSize;
        else
            StepSize = 0.04;
            OutStep = 0.04;
        end
    end

    if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
        StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
        OutStep = StepSize;
    end
    %--------------------------------------------------------------        
    FreqMapLG
    if exist('FMFT/inputL.txt') 
        delete FMFT/inputL.txt
    end
    if exist('FMFT/inputG.txt')
        delete FMFT/inputG.txt
    end
    if exist('FMFT/inputG3.txt') 
        delete FMFT/inputG3.txt
    end
end

clear DiffEquation

% --- Executes on button press in radiobutton_2D_pert.
function radiobutton_2D_pert_Callback(hObject, eventdata, handles)
Disable_General

if (get(handles.popupmenuODE,'Value') == 3 | get(handles.popupmenuODE,'Value') == 6)
    warndlg({'If you are sure that the problem is regular, then disable';...
             '''Watch falling into singularities'' in the Window menu'})
end

% --- Executes on button press in radiobutton_2D_nonpert.
function radiobutton_2D_nonpert_Callback(hObject, eventdata, handles)
Disable_General

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 PANEL:  Global analysis: rotated Delaunay
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function edit_Init_Gprime_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
function edit_Final_Gprime_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
function edit_Step_Gprime_Callback(hObject, eventdata, handles)
Disable_General
if strcmp(get(hObject,'String'), '0') == 1
    set(handles.edit_Final_Gprime, 'Enable', 'off')
end
if strcmp(get(hObject,'String'), '0') == 0
    set(handles.edit_Final_Gprime, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_Init_G3prime_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
function edit_Final_G3prime_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
function edit_Step_G3prime_Callback(hObject, eventdata, handles)
Disable_General
if strcmp(get(hObject,'String'), '0') == 1
    set(handles.edit_Final_G3prime, 'Enable', 'off')
end
if strcmp(get(hObject,'String'), '0') == 0
    set(handles.edit_Final_G3prime, 'Enable', 'on')
end

%--------------------------------------------------------------------------
function edit_LGG3_perprime_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
function edit_EnergyLGG3_Callback(hObject, eventdata, handles)
E_tot_str = get(handles.edit_EnergyLGG3,'String');
set(handles.edit_Energy,'String', E_tot_str);
set(handles.edit_EnergyPoincare,'String', E_tot_str);
set(handles.edit_EnergyLSD,'String', E_tot_str);
Disable_General

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_CalcPlot_LGG3prime.
function pushbutton_CalcPlot_LGG3prime_Callback(hObject, eventdata, handles)

clear global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
clear global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
clear global lambda step_i step_f x_vec y_vec tau tau_c W Ko
clear global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 G_ G_3

global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
global lambda step_i step_f x_vec y_vec tau tau_c W Ko
global perfid KeplerDir PhSpGeoDir
global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 G_ G_3
global row_tot col_tot G_string G3_string

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
if ((strcmp(ODE, 'Odex') == 1) & strcmp(get(handles.singularity, 'Checked'),'on'))
   warndlg({'When using Odex, the ''Watch falling into singularities'' option in Window menu must be disabled.';'Be sure that the problem is regular.'})
   return
end

Disable_General
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'off')

cd(KeplerDir)

row_tot = str2num(get(handles.edit_Step_Gprime,'String')) + 1;
col_tot = str2num(get(handles.edit_Step_G3prime,'String')) + 1;
if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if (((row_tot == 1) & (col_tot == 1)) | OutStep)
    else
        warndlg(['For a correct Windowed FFT the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.01). Please, redo ''Calculate...''.'])
        set(handles.edit_OutputStep,'String', num2str(0.01));
        set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'on')
        return
    end
end

if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    if StepSize
        OutStep = StepSize;
    else
        StepSize = 0.04;
        OutStep = 0.04;
    end
end

if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    OutStep = StepSize;
end

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

f_o =   0; 
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = 0;
tau_f = tau_total;

E_tot = str2num(get(handles.edit_EnergyLGG3,'String'));
lambda_tot = 1/sqrt(-2*E_tot);
lambda = lambda_tot;

%set(handles.count,'String', '0')
RotatedFreqMapLGG3
set(handles.pushbutton_CalcPlot_LGG3prime, 'Enable', 'on')
if (row_tot ~= 1) | (col_tot ~= 1)
    set(handles.pushbutton_FreqLGG3, 'Enable', 'on')
    set(handles.pushbutton_FMILGG3, 'Enable', 'on')
    set(handles.pushbutton_RatioLGG3, 'Enable', 'on')
end
if (row_tot ~= 1) & (col_tot ~= 1)
    set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'on')
end

delete FMFT/*.txt
clear DiffEquation
%--------------------------------------------------------------------------
% --- Executes on button press in radiobutton_Pert_LGG3.
function radiobutton_Pert_LGG3_Callback(hObject, eventdata, handles)
Disable_General

if (get(handles.popupmenuODE,'Value') == 3 | get(handles.popupmenuODE,'Value') == 6)
    warndlg({'If you are sure that the problem is regular, then disable';...
             '''Watch falling into singularities'' in the Window menu'})
end

% --- Executes on button press in radiobutton_NonPert_LGG3.
function radiobutton_NonPert_LGG3_Callback(hObject, eventdata, handles)
Disable_General

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_ClearAppend.
function pushbutton_ClearAppend_Callback(hObject, eventdata, handles)
clear global Ang_tot Act_tot
set(handles.pushbutton_ClearAppend,'Enable','off')
%{
%--------------------------------------------------------------------------
% --- Executes on button press in checkbox_gridLGG3.
function checkbox_gridLGG3_Callback(hObject, eventdata, handles)
%}
%--------------------------------------------------------------------------
function editGG3_uni_11_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_12_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_13_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_21_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_22_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_23_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_31_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_32_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

function editGG3_uni_33_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function editGG3_min_Freq1_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function editGG3_max_Freq1_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function editGG3_min_Freq2_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function editGG3_max_Freq2_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function editGG3_min_Freq3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function editGG3_max_Freq3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function nstep1LGG3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function nstep2LGG3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
function nstep3LGG3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLGG3, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLGG3, 'Enable', 'off')
set(handles.pushbutton_FMILGG3, 'Enable', 'off')
set(handles.pushbutton_RatioLGG3, 'Enable', 'off')

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_FreqLGG3.
function pushbutton_FreqLGG3_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 G_ G_3 row_tot col_tot G_string G3_string
if (row_tot == 1) & (col_tot ~= 1)
    FreqSecG_LGG3
elseif (col_tot == 1) & (row_tot ~= 1)
    FreqSecG3_LGG3
else (row_tot ~= 1) & (col_tot ~= 1);
    Freq_LGG3
%    clear handles2
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_FreqlevelLGG3.
function pushbutton_FreqlevelLGG3_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 G_ G_3 row_tot col_tot G_string G3_string
Freq_levelLGG3
%clear handles2
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_FMILGG3.
function pushbutton_FMILGG3_Callback(hObject, eventdata, handles)
global G_ G_3 FMI_1 FMI_2 FMI_3 row_tot col_tot G_string G3_string
if (row_tot == 1) & (col_tot ~= 1)
    DiffSecG_LGG3
elseif (col_tot == 1) & (row_tot ~= 1)
    DiffSecG3_LGG3
else (row_tot ~= 1) & (col_tot ~= 1);
    Diff_LGG3
%    clear handles2
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_RatioLGG3.
function pushbutton_RatioLGG3_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 G_ G_3 row_tot col_tot G_string G3_string
if (row_tot == 1) & (col_tot ~= 1)
    RatioSecG_LGG3
elseif (col_tot == 1) & (row_tot ~= 1)
    RatioSecG3_LGG3
else (row_tot ~= 1) & (col_tot ~= 1);
    Ratio_LGG3
%    clear handles2
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 PANEL:  Global analysis: rotated Pauli
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function edit_3D_init_S_Callback(hObject, eventdata, handles)
Disable_General

function edit_3D_final_S_Callback(hObject, eventdata, handles)
Disable_General

function edit_3D_step_S_Callback(hObject, eventdata, handles)
Disable_General
if strcmp(get(hObject,'String'), '0') == 1
    set(handles.edit_3D_final_S, 'Enable', 'off')
end
if strcmp(get(hObject,'String'), '0') == 0
    set(handles.edit_3D_final_S, 'Enable', 'on')
end

function edit_3D_init_D_Callback(hObject, eventdata, handles)
Disable_General

function edit_3D_final_D_Callback(hObject, eventdata, handles)
Disable_General

function edit_3D_step_D_Callback(hObject, eventdata, handles)
Disable_General
if strcmp(get(hObject,'String'), '0') == 1
    set(handles.edit_3D_final_D, 'Enable', 'off')
end
if strcmp(get(hObject,'String'), '0') == 0
    set(handles.edit_3D_final_D, 'Enable', 'on')
end
%--------------------------------------------------------------------------
function edit_phiR_Callback(hObject, eventdata, handles)
Disable_General

function edit_EnergyLSD_Callback(hObject, eventdata, handles)
E_tot_str = get(handles.edit_EnergyLSD,'String');
set(handles.edit_Energy,'String', E_tot_str);
set(handles.edit_EnergyPoincare,'String', E_tot_str);
set(handles.edit_EnergyLGG3,'String', E_tot_str);
Disable_General
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_CalcPlot_LSDprime.
function pushbutton_CalcPlot_LSDprime_Callback(hObject, eventdata, handles)
clear global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
clear global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
clear global lambda step_i step_f x_vec y_vec tau tau_c W Ko
clear global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 S3prime D3prime

global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg4 Hp1 Hp2 Hp3 Hp4 Hp5
global lambda step_i step_f x_vec y_vec tau tau_c W Ko
global perfid KeplerDir PhSpGeoDir
global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 S3prime D3prime
global row_tot col_tot S3_str D3_str

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
if ((strcmp(ODE, 'Odex') == 1) & strcmp(get(handles.singularity, 'Checked'),'on'))
   warndlg({'When using Odex, the ''Watch falling into singularities'' option in Window menu must be disabled.';'Be sure that the problem is regular.'})
   return
end

Disable_General
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'off')
cd(KeplerDir)
row_tot = str2num(get(handles.edit_3D_step_S,'String')) + 1;
col_tot = str2num(get(handles.edit_3D_step_D,'String')) + 1;
if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if ((row_tot == 1) & (col_tot == 1)) | OutStep
    else
        warndlg(['For a correct Windowed FFT the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.01). Please, redo ''Calculate...''.'])
        set(handles.edit_OutputStep,'String', num2str(0.01));
        set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'on')
        return
    end
end

if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    if StepSize
        OutStep = StepSize;
    else
        StepSize = 0.04;
        OutStep = 0.04;
    end
end

if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    OutStep = StepSize;
end

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

f_o =   0; 
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = 0;
tau_f = tau_total;

E_tot = str2num(get(handles.edit_EnergyLSD,'String'));
lambda_tot = 1/sqrt(-2*E_tot);
lambda = lambda_tot;

RotatedFreqMapLSD
set(handles.pushbutton_CalcPlot_LSDprime, 'Enable', 'on')
if (row_tot ~= 1) | (col_tot ~= 1)
    set(handles.pushbutton_FreqLSD, 'Enable', 'on')
    set(handles.pushbutton_FMILSD, 'Enable', 'on')
    set(handles.pushbutton_RatioLSD, 'Enable', 'on')
end
if (row_tot ~= 1) & (col_tot ~= 1)
    set(handles.pushbutton_FreqlevelLSD, 'Enable', 'on')
end

delete FMFT/*.txt
clear DiffEquation

%--------------------------------------------------------------
% --- Executes on button press in radiobutton_Pert_LSD.
function radiobutton_Pert_LSD_Callback(hObject, eventdata, handles)
Disable_General

if (get(handles.popupmenuODE,'Value') == 3 | get(handles.popupmenuODE,'Value') == 6)
     warndlg({'If you are sure that the problem is regular, then disable';...
             '''Watch falling into singularities'' in the Window menu'})
end

% --- Executes on button press in radiobutton_NonPert_LSD.
function radiobutton_NonPert_LSD_Callback(hObject, eventdata, handles)
Disable_General

%---------------------------------------------------------------
function editSD_uni_11_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_12_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_13_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_21_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_22_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_23_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_31_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_32_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_uni_33_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

%---------------------------------------------------------------
function editSD_max_Freq1_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_min_Freq1_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_max_Freq2_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_min_Freq2_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_max_Freq3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function editSD_min_Freq3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function nstep1LSD_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function nstep2LSD_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

function nstep3LSD_Callback(hObject, eventdata, handles)
set(handles.pushbutton_FreqLSD, 'Enable', 'off')
set(handles.pushbutton_FreqlevelLSD, 'Enable', 'off')
set(handles.pushbutton_FMILSD, 'Enable', 'off')
set(handles.pushbutton_RatioLSD, 'Enable', 'off')

%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_FreqLSD.
function pushbutton_FreqLSD_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 S3prime D3prime row_tot col_tot S3_str D3_str
if (row_tot == 1) & (col_tot ~= 1)
    FreqSecS_LSD
elseif (col_tot == 1) & (row_tot ~= 1)
    FreqSecD_LSD
else (row_tot ~= 1) & (col_tot ~= 1);
    Freq_LSD
%   clear handles2
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_FreqlevelLSD.
function pushbutton_FreqlevelLSD_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 S3prime D3prime row_tot col_tot S3_str D3_str
Freq_levelLSD
%clear handles2
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_FMILSD.
function pushbutton_FMILSD_Callback(hObject, eventdata, handles)
global S3prime D3prime FMI_1 FMI_2 FMI_3 row_tot col_tot S3_str D3_str
if (row_tot == 1) & (col_tot ~= 1)
    DiffSecS_LSD
elseif (col_tot == 1) & (row_tot ~= 1)
    DiffSecD_LSD
else (row_tot ~= 1) & (col_tot ~= 1);
    Diff_LSD
%    clear handles2
end
%--------------------------------------------------------------------------
% --- Executes on button press in pushbutton_RatioLSD.
function pushbutton_RatioLSD_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 S3prime D3prime row_tot col_tot S3_str D3_str
if (row_tot == 1) & (col_tot ~= 1)
    RatioSecS_LSD
elseif (col_tot == 1) & (row_tot ~= 1)
    RatioSecD_LSD
else (row_tot ~= 1) & (col_tot ~= 1);
    Ratio_LSD
%    clear handles2
end
%--------------------------------------------------------------------------
function edit_ClearMemory_Callback(hObject, eventdata, handles)
if (str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String')) &...
        strcmp(get(handles.LongtimeFA, 'Visible'),'on') == 1)
    set(handles.edit_ClearMemory,'String',get(handles.ComputeLFA,'String'))  
end

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%--------------------------------------------------------------------------
function ComputeLFA_Callback(hObject, eventdata, handles)
if str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String'))
    set(handles.ComputeLFA,'String',get(handles.edit_ClearMemory,'String'))  
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Menu' File
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Title
function File_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function Load_Callback(hObject, eventdata, handles)
global KeplerDir
cd(KeplerDir);
[filename, pathname] = uigetfile( ...
     {'*.mat', 'All MAT-Files (*.mat)'; ...
         '*.*','All Files (*.*)'}, ...
    'Load Initial Data','Init/');
if isequal([filename,pathname],[0,0])
    return
else
    [pathstr, name, ext] = fileparts(filename);
    cd(pathname)
    load([name,'.mat'])
    cd(KeplerDir);
end

set(handles.popupmenuHp1,'Value', Hp1)
set(handles.popupmenuHp2,'Value', Hp2)
set(handles.popupmenuHp3,'Value', Hp3)
set(handles.popupmenuHp4,'Value', Hp4)
set(handles.popupmenuHp5,'Value', Hp5)
set(handles.edit_epsilon1,'String', epsilon1)
set(handles.edit_epsilon2,'String', epsilon2)
set(handles.edit_epsilon3,'String', epsilon3)
set(handles.edit_epsilon4,'String', epsilon4)
set(handles.edit_epsilon5,'String', epsilon5)
set(handles.q1_value,'String', q1)
set(handles.q2_value,'String', q2)
set(handles.q3_value,'String', q3)
set(handles.p1_value,'String', p1)
set(handles.p2_value,'String', p2)
set(handles.p3_value,'String', p3)
set(handles.edit_smaxis,'String', sm)
set(handles.edit_Eccentricity,'String', ecc)
set(handles.edit_AscNode,'String', Omega)
set(handles.edit_ArgPericenter,'String', omega)
set(handles.edit_Inclination,'String', incl)
set(handles.edit_TrueAnomaly,'String', f)
set(handles.edit_S01,'String', SO1)
set(handles.edit_S02,'String', SO2)
set(handles.edit_S03,'String', SO3)
set(handles.edit_D01,'String', DO1)
set(handles.edit_D02,'String', DO2)
set(handles.edit_D03,'String', DO3)
set(handles.uipanel_Pauli,'Visible', Visible)
set(handles.radiobutton_yes,'Value', yes)
set(handles.radiobutton_no,'Value', no)
set(handles.edit_Energy,'String', TotE)
set(handles.edit_EnergyPoincare,'String', TotE)
set(handles.edit_EnergyLGG3,'String', TotE)
set(handles.edit_EnergyLSD,'String', TotE)
set(handles.pushbutton_Integrate, 'Enable', 'on')
set(handles.pushbutton_StandIntegrate, 'Enable', 'on')

Disable_General

set(handles.radiobutton_Delaunay,'Value',1)
set(handles.radiobutton_Pauli,'Value',0)
set(handles.radiobutton_User,'Value',0)
if strcmp(get(handles.uipanel_Pauli,'Visible') , 'on') == 1
    set(handles.radiobutton_Delaunayprime, 'Enable', 'on', 'Value',0)
    set(handles.radiobutton_Pauliprime, 'Enable', 'on', 'Value',0)  
else
    set(handles.radiobutton_Delaunayprime, 'Enable', 'off')
    set(handles.radiobutton_Pauliprime, 'Enable', 'off')
end

set(handles.pushbutton_Up_Pauli, 'Enable', 'off')

% --------------------------------------------------------------------
function Save_Callback(hObject, eventdata, handles)
global KeplerDir
cd(KeplerDir);
[filename, pathname] = uiputfile( ...
     {'*.mat', 'MAT-Files (*.mat)'; ...
        '*.*','All Files (*.*)'}, ...
    'Save Initial Data','Init/');
if isequal([filename,pathname],[0,0])
    return
else
    val1 = get(handles.popupmenuHp1,'Value');
    val2 = get(handles.popupmenuHp2,'Value');
    val3 = get(handles.popupmenuHp3,'Value');
    val4 = get(handles.popupmenuHp4,'Value');
    val4b = get(handles.popupmenuHp5,'Value');
    val5 = get(handles.edit_epsilon1,'String');
    val6 = get(handles.edit_epsilon2,'String');
    val7 = get(handles.edit_epsilon3,'String');
    val8 = get(handles.edit_epsilon4,'String');
    val8b = get(handles.edit_epsilon5,'String');
    val9 = get(handles.q1_value,'String');
    val10 = get(handles.q2_value,'String');
    val11 = get(handles.q3_value,'String');
    val12 = get(handles.p1_value,'String');
    val13 = get(handles.p2_value,'String');
    val14 = get(handles.p3_value,'String');
    val15 = get(handles.edit_smaxis,'String');
    val16 = get(handles.edit_Eccentricity,'String');
    val17 = get(handles.edit_AscNode,'String');
    val18 = get(handles.edit_ArgPericenter,'String');
    val19 = get(handles.edit_Inclination,'String');
    val20 = get(handles.edit_TrueAnomaly,'String');
    val21 = get(handles.edit_S01,'String');
    val22 = get(handles.edit_S02,'String');
    val23 = get(handles.edit_S03,'String');
    val24 = get(handles.edit_D01,'String');
    val25 = get(handles.edit_D02,'String');
    val26 = get(handles.edit_D03,'String');
    val27 = get(handles.uipanel_Pauli,'Visible');
    val28 = get(handles.radiobutton_yes,'Value');
    val29 = get(handles.radiobutton_no,'Value');
    val31 = get(handles.edit_Energy,'String');

    InitStruct = struct('Hp1',val1, 'Hp2',val2, 'Hp3',val3, 'Hp4',val4, 'Hp5',val4b,...
        'epsilon1',val5, 'epsilon2',val6, 'epsilon3',val7, 'epsilon4',val8, 'epsilon5',val8b,...
        'q1',val9, 'q2',val10, 'q3',val11,...
        'p1',val12, 'p2',val13, 'p3',val14,...
        'sm',val15, 'ecc',val16, 'Omega',val17,...
        'omega',val18, 'incl',val19, 'f',val20,...
        'SO1',val21, 'SO2',val22, 'SO3',val23,...
        'DO1',val24, 'DO2',val25, 'DO3',val26,...
        'Visible',val27,'yes',val28,'no',val29,...
        'TotE',val31);

    save([pathname,filename], '-struct', 'InitStruct')
end

% --------------------------------------------------------------------
function closeall_Callback(hObject, eventdata, handles)
close all hidden

% --------------------------------------------------------------------
function Save_exit_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

% --------------------------------------------------------------------
function Save_now_Callback(hObject, eventdata, handles)
global KeplerDir PhSpGeoDir
InitStructure
cd(KeplerDir)
cd ..        
save('Setting.mat', '-struct', 'InitStr')
cd(KeplerDir)

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Menu' Window
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Title
function Window_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function CloseAll_Callback(hObject, eventdata, handles)
close all

% --------------------------------------------------------------------
function SingleFigures_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

% --------------------------------------------------------------------
function waitbars_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
    set(handles.SlowWaitbars, 'Checked','off');
end

% --------------------------------------------------------------------
function SlowWaitbars_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
    set(handles.waitbars, 'Checked','off');
end

% --------------------------------------------------------------------
function warningbox_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

% --------------------------------------------------------------------
function singularity_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

%--------------------------------------------------------------------------
function watch_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

% --------------------------------------------------------------------
function perform_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

% --------------------------------------------------------------------
function LGG3_long_FMFT_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
    set(handles.pushbutton_StandIntegrate,'Enable', 'on')
    set(handles.LongtimeFA, 'Visible','off');
    if (strcmp(get(handles.uipanel_Freq3D_LSD,'Visible') , 'on') == 1) |...
          (strcmp(get(handles.uipanel_Freq3D_LGG3,'Visible') , 'on') == 1) |...
          (strcmp(get(handles.uipanel_PoincFreq_2D,'Visible') , 'on') == 1)
      % do nothing
    else
        set(handles.uipanel_from_to, 'Visible','on');
    end
else
    set(gcbo, 'Checked','on');    
    set(handles.LSD_long_FMFT, 'Checked','off');
    set(handles.pushbutton_StandIntegrate,'Enable', 'off')
    set(handles.edit_Step_Gprime,'String', 0)
    set(handles.edit_Step_G3prime,'String', 0)
    set(handles.edit_Final_Gprime,'Enable', 'off')
    set(handles.edit_Final_G3prime,'Enable', 'off')
    if (strcmp(get(handles.uipanel_Freq3D_LSD,'Visible') , 'on') == 1) |...
          (strcmp(get(handles.uipanel_Freq3D_LGG3,'Visible') , 'on') == 1)
        set(handles.LongtimeFA, 'Visible','on');
    elseif (strcmp(get(handles.uipanel_PoincFreq_2D,'Visible') , 'on') == 1)
        set(handles.LongtimeFA, 'Visible','off');
    else
        set(handles.LongtimeFA, 'Visible','on');
        set(handles.uipanel_from_to, 'Visible','off');
    end
    if str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String'))
        set(handles.ComputeLFA,'String',get(handles.edit_ClearMemory,'String'))  
    end
end

% --------------------------------------------------------------------
function LSD_long_FMFT_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
    set(handles.pushbutton_StandIntegrate,'Enable', 'on')
    set(handles.LongtimeFA, 'Visible','off');
     if (strcmp(get(handles.uipanel_Freq3D_LSD,'Visible') , 'on') == 1) |...
          (strcmp(get(handles.uipanel_Freq3D_LGG3,'Visible') , 'on') == 1)
      % do nothing
    else
        set(handles.uipanel_from_to, 'Visible','on');
    end   
else
    set(gcbo, 'Checked','on');
    set(handles.LGG3_long_FMFT, 'Checked','off');
    set(handles.pushbutton_StandIntegrate,'Enable', 'off')
    set(handles.edit_3D_step_S,'String', 0)
    set(handles.edit_3D_step_D,'String', 0)
    set(handles.edit_3D_final_S,'Enable', 'off')
    set(handles.edit_3D_final_D,'Enable', 'off')
    if (strcmp(get(handles.uipanel_Freq3D_LSD,'Visible') , 'on') == 1) |...
          (strcmp(get(handles.uipanel_Freq3D_LGG3,'Visible') , 'on') == 1)
        set(handles.LongtimeFA, 'Visible','on');
     else
        set(handles.LongtimeFA, 'Visible','on');
        set(handles.uipanel_from_to, 'Visible','off');       
    end
    if str2num(get(handles.edit_ClearMemory,'String')) < str2num(get(handles.ComputeLFA,'String'))
        set(handles.ComputeLFA,'String',get(handles.edit_ClearMemory,'String'))  
    end    
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Menu' Figure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function no_degree_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function LargeMS_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function Figure_Callback(hObject, eventdata, handles)
if get(0,'CurrentFigure')
    set(handles.save_fig,'Enable','on')
    set(handles.MouseTrack,'Enable','on')
    set(handles.scrollplot,'Enable','on')
    set(handles.magnify,'Enable','on')
else
    set(handles.save_fig,'Enable','off')
    set(handles.MouseTrack,'Enable','off')
    set(handles.scrollplot,'Enable','off')
    set(handles.magnify,'Enable','off')
end

%---------------------------------------------------------------------
% -------------- Sub Menu' Save Figure -------------------------------
function save_fig_Callback(hObject, eventdata, handles)
% Do nothing

% --------------------------------------------------------------------
%{
function save_eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'eps', '-fonts')
else
    savefig(name, 'eps', '-fonts')
end
%}

% --------------------------------------------------------------------
function save_pdf_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'pdf', '-fonts')   
else
    savefig(name, 'pdf', '-fonts')
end

% --------------------------------------------------------------------
function save_png_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savefig('CurrentFigure', 'png', '-r1200')   
else
    savefig(name, 'png', '-r1200')
end

% --------------------------------------------------------------------
function jpeg2eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
global PhSpGeoDir
if strcmp(name, '')
    savefig('CurrentFigure', 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 CurrentFigure.jpeg > CurrentFigure.eps'];
    eval(cmd_string)
else
    savefig(name, 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 ',name,'.jpeg > ',name,'.eps'];
    eval(cmd_string)    
end
%-------------------% End Sub Figure----------------------------------

% --------------------------------------------------------------------
function MouseTrack_Callback(hObject, eventdata, handles)
Mouse_track
figure(get(0,'CurrentFigure'))

% --------------------------------------------------------------------
function scrollplot_Callback(hObject, eventdata, handles)
scrollplot('Axis','xy')
figure(get(0,'CurrentFigure'))

% --------------------------------------------------------------------
function magnify_Callback(hObject, eventdata, handles)
magnify;
figure(get(0,'CurrentFigure'))

% --------------------------------------------------------------------
function VolumeVis_Callback(hObject, eventdata, handles)
global KeplerDir PhSpGeoDir
cd([KeplerDir, '/Util/sliceomatic'])
sliceomatic

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Menu' Normal form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Title
function Normalform_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function SQZ_Callback(hObject, eventdata, handles)
SQZ
% --------------------------------------------------------------------
function Cr3b_Callback(hObject, eventdata, handles)
Cr3b
% --------------------------------------------------------------------
function Sat_Callback(hObject, eventdata, handles)
Sat
%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Menu' Help
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Title
function Help_gen_Callback(hObject, eventdata, handles)

% --------------------------------------------------------------------
function impatient_Callback(hObject, eventdata, handles)
popupmessage('Impatient.txt', 'Help for impatient')
% --------------------------------------------------------------------
function EnterHelp_Callback(hObject, eventdata, handles)
set(handles.figureMain,'CSHelpMode','on');
% --------------------------------------------------------------------
function QuitHelp_Callback(hObject, eventdata, handles)
set(handles.figureMain,'CSHelpMode','off');

% --------------------------------------------------------------------
function about_Callback(hObject, eventdata, handles)
About

% --------------------------------------------------------------------
function credits_Callback(hObject, eventdata, handles)
Credits

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Multicore
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
function count_Callback(hObject, eventdata, handles)
% --- Executes during object creation, after setting all properties.
function count_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%}
% --- Executes on button press in pushbutton_StartSlave_LGG3.
function pushbutton_StartSlave_LGG3_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave_LGG3, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)

clear global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
clear global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
clear global lambda step_i step_f x_vec y_vec tau tau_c W Ko
clear global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 G_ G_3

global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
global lambda step_i step_f x_vec y_vec tau tau_c W Ko
global perfid KeplerDir
global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 G_ G_3
global row_tot col_tot G_string G3_string

Disable_General
cd(KeplerDir)
row_tot = str2num(get(handles.edit_Step_Gprime,'String')) + 1;
col_tot = str2num(get(handles.edit_Step_G3prime,'String')) + 1;
if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if (((row_tot == 1) & (col_tot == 1)) | OutStep)
    else
        warndlg(['For a correct Windowed FFT the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.01). Please, redo ''Calculate and plot''.'])
        set(handles.edit_OutputStep,'String', num2str(0.01));
        return
    end
end

if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    if StepSize
        OutStep = StepSize;
    else
        StepSize = 0.04;
        OutStep = 0.04;
    end
end

if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    OutStep = StepSize;
end

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

f_o =   0; 
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = 0;
tau_f = tau_total;

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

E_tot = str2num(get(handles.edit_EnergyLGG3,'String'));
lambda_tot = 1/sqrt(-2*E_tot);
lambda = lambda_tot;

if isdeployed
    % do nothing
else
    if get(handles.radiobutton_Pert_LGG3,'Value') == 1
        Symbolic
        Write2file
        waitfor(exist('DiffEquation'))
    elseif get(handles.radiobutton_NonPert_LGG3,'Value') == 1
        SymbolicNonPert
        Write2fileNonPert
        waitfor(exist('DiffEquation'))
    end
end

startmulticoreslave('../multicorefiles')

% --- Executes on button press in pushbutton_StartSlave_LSD.
function pushbutton_StartSlave_LSD_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave_LSD, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)

clear global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
clear global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
clear global lambda step_i step_f x_vec y_vec tau tau_c W Ko
clear global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 S3prime D3prime

global q_vec p_vec q_vec_o p_vec_o tau_total tau_i tau_f
global epsilon1 epsilon2 epsilon3 epsilon4 epsilon5 deg1 deg2 deg3 deg4 deg5 Hp1 Hp2 Hp3 Hp4 Hp5
global lambda step_i step_f x_vec y_vec tau tau_c W Ko
global perfid KeplerDir
global freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 S3prime D3prime
global row_tot col_tot S3_str D3_str

Disable_General
cd(KeplerDir)
row_tot = str2num(get(handles.edit_3D_step_S,'String')) + 1;
col_tot = str2num(get(handles.edit_3D_step_D,'String')) + 1;
if strcmp(get(handles.uiPanel_Options,'Visible'),'on')    
    OutStep = str2num(get(handles.edit_OutputStep, 'String'));
    if ((row_tot == 1) & (col_tot == 1)) | OutStep
    else
        warndlg(['For a correct Windowed FFT the integration MUST be performed ',...
          'with a constant Output Step (default value: 0.01). Please, redo ''Calculate and plot''.'])
        set(handles.edit_OutputStep,'String', num2str(0.01));
        return
    end
end

if strcmp(get(handles.uiPanel_TomOptions,'Visible'),'on')
    StepSize = str2num(get(handles.edit_StepSize,'String'));
    if StepSize
        OutStep = StepSize;
    else
        StepSize = 0.04;
        OutStep = 0.04;
    end
end

if strcmp(get(handles.uipanel_RungeKutta,'Visible'),'on')
    StepSize = str2num(get(handles.edit_FixedStepSize,'String'));
    OutStep = StepSize;
end

contents = get(handles.popupmenuHp1,'String');
item = get(handles.popupmenuHp1,'Value');
Hp1 = char(contents(item));
degrees = get(handles.popupmenuHp1,'UserData');
deg1 = degrees(item);

contents = get(handles.popupmenuHp2,'String');
item = get(handles.popupmenuHp2,'Value');
Hp2 = char(contents(item));
degrees = get(handles.popupmenuHp2,'UserData');
deg2 = degrees(item);

contents = get(handles.popupmenuHp3,'String');
item = get(handles.popupmenuHp3,'Value');
Hp3 = char(contents(item));
degrees = get(handles.popupmenuHp3,'UserData');
deg3 = degrees(item);

contents = get(handles.popupmenuHp4,'String');
item = get(handles.popupmenuHp4,'Value');
Hp4 = char(contents(item));
degrees = get(handles.popupmenuHp4,'UserData');
deg4 = degrees(item);

contents = get(handles.popupmenuHp5,'String');
item = get(handles.popupmenuHp5,'Value');
Hp5 = char(contents(item));
degrees = get(handles.popupmenuHp5,'UserData');
deg5 = degrees(item);

epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
epsilon4 = str2num(get(handles.edit_epsilon4,'String'));
epsilon5 = str2num(get(handles.edit_epsilon5,'String'));

f_o =   0; 
tau_total = str2num(get(handles.total_cycles,'String'));
tau_i = 0;
tau_f = tau_total;

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

E_tot = str2num(get(handles.edit_EnergyLSD,'String'));
lambda_tot = 1/sqrt(-2*E_tot);
lambda = lambda_tot;

if isdeployed
    % do nothing
else
    if get(handles.radiobutton_Pert_LSD,'Value') == 1
        Symbolic
        Write2file
        waitfor(exist('DiffEquation'))
    elseif get(handles.radiobutton_NonPert_LSD,'Value') == 1
        SymbolicNonPert
        Write2fileNonPert
        waitfor(exist('DiffEquation'))
    end
end

startmulticoreslave('../multicorefiles')
%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    END of CODE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%