%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sm_ax_o = 1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Integrate a list of initial values
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Avoid visualizing the wrong waitbar
if steps_2D ~= 0
    global pick            
    pick = tau_total;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isdeployed
    % do nothing
else
    if get(handles.radiobutton_2D_pert,'Value') == 1
        Symbolic
        Write2file
        waitfor(exist('DiffEquation'))
    elseif get(handles.radiobutton_2D_nonpert,'Value') == 1
        SymbolicNonPert
        Write2fileNonPert
        waitfor(exist('DiffEquation'))
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%          Begin numerical computation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if steps_2D == 0
    step = 1;
    G_oinit = G_ofinal;

    if strcmp(get(handles.waitbars, 'Checked'),'on')
        global pick                                                                         %%%%% waitbar
%        h = waitbar(0,'Please wait...', 'Units', 'pixels', 'Position', [405 550 360 70]);   %%%%% waitbar
         h = waitbar(0,'Please wait...');
        pick = -tau_total/100;                                                              %%%%% waitbar
    end

else
    step = (G_ofinal - G_oinit)/steps_2D;
%    h = waitbar(0,'Please wait...', 'Units', 'pixels', 'Position', [405 550 360 70]);
     h = waitbar(0,'Please wait...');
end
list_number = 1;
j = 1;
for Gxxx = G_oinit : step : G_ofinal
    if get(handles.radiobutton_2D_system,'Value') == 1
        if G_ofinal >= 0
            incl_o = 0;
        else
            incl_o = 180;
        end
    else
        if get(handles.NormG3,'Value') == 1;
            incl_o = 180/pi*acos(G3_o/Gxxx);
        elseif get(handles.TrueG3,'Value') == 1;             
            incl_o = 180/pi*acos(G3_o/Gxxx/sqrt(sm_ax_o));
        end
    end
%-------------------------------------------------------------------------------
    E_tot = str2num(get(handles.edit_EnergyPoincare,'String'));
    lambda_tot = 1/sqrt(-2*E_tot);
    lambd = lambda_tot + 1;
    lambda = 1.0;
    sm_ax_o = lambda_tot^2;
    Ecc_o = sqrt(1-Gxxx^2);          %Normalized G
%   Ecc_o = sqrt(1-Gxxx^2./sm_ax_o);    
    kk = 0;
    while abs(lambd - lambda_tot) > 1e-02
        if kk > 50
            break
        end
        
        Keplerian2Cartesian
        lambd = 1/sqrt(-2*(1/2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')...
            + Hp(q_vec_o, p_vec_o, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5)));
        
        if (~isreal(lambd) | isnan(lambd))
            break
        end        
        sm_ax_o = lambda_tot^2*sm_ax_o/lambd^2;

        if get(handles.radiobutton_2D_system,'Value') == 1
            if G_ofinal >= 0
                incl_o = 0;
            else
                incl_o = 180;
            end
        else
            if get(handles.NormG3,'Value') == 1;
                incl_o = 180/pi*acos(G3_o/Gxxx);
            elseif get(handles.TrueG3,'Value') == 1;             
                incl_o = 180/pi*acos(G3_o/Gxxx/sqrt(sm_ax_o));
            end
        end                
        kk = kk + 1;
    end

    if (~isreal(lambd) | isnan(lambd))
        Keplerian2Cartesian
    end
    
    f = @(z)1/sqrt(-2*(1/2*z^2*p_vec_o*p_vec_o' - 1/sqrt(q_vec_o*q_vec_o')*z^2 ...
            + Hp(q_vec_o/z^2, p_vec_o*z, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5, Hp1, Hp2, Hp3, Hp4, Hp5))) - lambda_tot;
    opts = optimset('Display','off');
    
    try
        a = fzero(f,1,opts);
    catch
        warndlg(sprintf(['With the selected value of Total Energy I am not able to find the initial conditions.']))
        return
    end    

    if isnan(a)
        disp('With the selected value of Total Energy it is impossible to find')
        disp('the initial conditions for a correct value of G and G3.')
        disp('The corresponding section will be left blank.')
        disp('    ')
        waitbar((Gxxx-G_oinit+step)/(G_ofinal-G_oinit+step))
        continue
    end
    
    q_vec_o = q_vec_o/a^2;
    p_vec_o = p_vec_o*a;
   
    lambda = lambda_tot;
    x_vec_o = 1/(lambda^2)*q_vec_o;
    y_vec_o = lambda*p_vec_o;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if get(handles.radiobutton_2D_pert,'Value') == 1  
        [Uo, Vo] = xy2uv(x_vec_o, y_vec_o);
    elseif get(handles.radiobutton_2D_nonpert,'Value') == 1   
        [z_vec_o,  w_vec_o] = xy2zw(x_vec_o,  y_vec_o);
        Uo = z_vec_o';
        Vo = w_vec_o';
    end
    block = str2num(get(handles.edit_block,'String'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     TOM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if strcmp(ODE, 'Tom') == 1
        met = str2num(get(handles.edit_met,'String'));
        OutStep = str2num(get(handles.edit_StepSize,'String'));
        RelTolNewt = str2num(get(handles.edit_RelTolNewt,'String'));
        Itnlmax = str2num(get(handles.edit_Itnlmax,'String'));         
        tom_options = tomgset('met',met,'Order',10,'StepSize',OutStep,...
            'RelTolNewt',RelTolNewt,...
            'Vectorized','off','OutputSteps',1,...
            'Itnlmax',Itnlmax,'Stats_step','off','Stats','off');

        if block
            n_cycle = floor(tau_total/block);
            k = 1; w = []; tau_ = [];
            for k = 1:n_cycle               
                sol = tomgm('DiffEquation', [(k-1)*block  k*block], [Uo; Vo], tom_options);               
                W = sol.y';
                tau_c = sol.x;    
                w = [w; W(1:length(W)-1, :)];
                tau_ = [tau_; tau_c(1:length(W)-1)];
                W_o = W(length(W), :);
                Uo = W_o(1:4)';
                Vo = W_o(5:8)';

                if get(handles.radiobutton_Pert,'Value') == 1
                    [xo yo] = uv2xy(Uo, Vo);       
                    [Uo Vo] = xy2uv(xo, yo);        
                    [xo yo] = uv2xy(Uo, Vo);
                elseif get(handles.radiobutton_NonPert,'Value') == 1
                    [xo yo] = zw2xy(Uo, Vo);
                    [Uo Vo] = xy2zw(xo, yo);           
                    [xo yo] = zw2xy(Uo, Vo);
                end

%---------------------- SOSTITUZIONE ---------------------------------------------------------                
%{
                Ktot = 1.001;
                while abs(Ktot-1) > 5*eps
                    Ktot = 1/2*sqrt(xo*xo')*(yo*yo'+1) + sqrt(xo*xo')*...
                    Kp(xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4,...
                        deg1, deg2, deg3, deg4, Hp1, Hp2, Hp3, Hp4);
                    xo = xo/Ktot;
                end           
%}
                f = @(z)1/2*sqrt(z^2*xo*xo')*(yo*yo'+1) + sqrt(z^2*xo*xo')*...
                    Kp(z*xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5,...
                        deg1, deg2, deg3, deg4, deg5, Hp1, Hp2, Hp3, Hp4, Hp5) - 1;
                a = fzero(f,1);
                xo =a*xo;
%---------------------------------------------------------------------------------------------            

                if get(handles.radiobutton_Pert,'Value') == 1
                    [Uo Vo] = xy2uv(xo, yo);
                elseif get(handles.radiobutton_NonPert,'Value') == 1
                    [Uo Vo] = xy2zw(xo, yo);
                    Uo = Uo'; Vo = Vo';
                end     
            end
            if (n_cycle*block ~= tau_total)
                sol = tomgm('DiffEquation', [n_cycle*block  tau_total], [Uo; Vo], tom_options);
                W = sol.y';
                tau_c = sol.x;
                W = [w; W];
                tau_c = [tau_; tau_c];       
            else
                W = w;
                tau_c = tau_;
            end
        else                 
            sol = tomgm('DiffEquation', [0 tau_total], [Uo; Vo], tom_options);
            W = sol.y';
            tau_c = sol.x;
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Runge-Kutta
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%           
    elseif (strcmp(ODE, 'RungeKutta4') == 1) | (strcmp(ODE, 'RungeKutta5') == 1)
        OutStep = str2num(get(handles.edit_FixedStepSize,'String'));  
        tau_c = (0 : OutStep : tau_total)';
        W = eval([ODE, '(@DiffEquation, tau_c, [Uo; Vo])']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     IRKGauss
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%         
    elseif (strcmp(ODE, 'IRKGauss') == 1)
        OutStep = str2num(get(handles.edit_FixedStepSize,'String'));
        opt.method = str2num(get(handles.edit_IRKMeth,'String'));
        if block
            opt.nstep = block/OutStep;
            n_cycle = floor(tau_total/block);
            k = 1; w = []; tau_ = [];
            for k = 1:n_cycle        
                [tau_c,W] = eval([ODE, '(@DiffEquation, [(k-1)*block , k*block], [Uo; Vo], opt)']);        
                w = [w; W(1:length(W)-1, :)];
                tau_ = [tau_; tau_c(1:length(W)-1)];
                W_o = W(length(W), :);
                Uo = W_o(1:4)';
                Vo = W_o(5:8)';

                if get(handles.radiobutton_Pert,'Value') == 1
                    [xo yo] = uv2xy(Uo, Vo);       
                    [Uo Vo] = xy2uv(xo, yo);        
                    [xo yo] = uv2xy(Uo, Vo);
                elseif get(handles.radiobutton_NonPert,'Value') == 1
                    [xo yo] = zw2xy(Uo, Vo);
                    [Uo Vo] = xy2zw(xo, yo);           
                    [xo yo] = zw2xy(Uo, Vo);
                end

%---------------------- SOSTITUZIONE ---------------------------------------------------------                
%{
                Ktot = 1.001;
                while abs(Ktot-1) > 5*eps
                    Ktot = 1/2*sqrt(xo*xo')*(yo*yo'+1) + sqrt(xo*xo')*...
                    Kp(xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4,...
                        deg1, deg2, deg3, deg4, Hp1, Hp2, Hp3, Hp4);
                    xo = xo/Ktot;
                end           
%}
                f = @(z)1/2*sqrt(z^2*xo*xo')*(yo*yo'+1) + sqrt(z^2*xo*xo')*...
                    Kp(z*xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5,...
                        deg1, deg2, deg3, deg4, deg5, Hp1, Hp2, Hp3, Hp4, Hp5) - 1;
                a = fzero(f,1);
                xo =a*xo;
%---------------------------------------------------------------------------------------------            

                if get(handles.radiobutton_Pert,'Value') == 1
                    [Uo Vo] = xy2uv(xo, yo);
                elseif get(handles.radiobutton_NonPert,'Value') == 1
                    [Uo Vo] = xy2zw(xo, yo);
                    Uo = Uo'; Vo = Vo';
                end     
            end
            if (n_cycle*block ~= tau_total)
                opt.nstep = (tau_total - n_cycle*block)/OutStep;
                [tau_c,W] = eval([ODE, '(@DiffEquation, [n_cycle*block , tau_total], [Uo; Vo], opt)']);
                W = [w; W];
                tau_c = [tau_; tau_c];
            else
                W = w;
                tau_c = tau_;
            end
        else            
            opt.method = str2num(get(handles.edit_IRKMeth,'String'));
            opt.nstep = tau_total/OutStep;          
            [tau_c,W] = eval([ODE, '(@DiffEquation, [0, tau_total], [Uo; Vo], opt)']);
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Other ODE solver
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    else
        Rel_Tol = str2num(get(handles.edit_RelTol,'String'));
        Abs_Tol = str2num(get(handles.edit_AbsTol,'String'));
        Init_Step = str2num(get(handles.edit_InitialStep,'String'));
        Max_Step = str2num(get(handles.edit_MaxStep,'String'));
        OutStepst = get(handles.edit_OutputStep,'String');
        if isempty(OutStepst)
            Output_Step = '';
        else
            Output_Step = [':',OutStepst,':'];
        end
        options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
            'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]); 
        if block
            n_cycle = floor(tau_total/block);
            k = 1; w = []; tau_ = [];
            for k = 1:n_cycle            
                [tau_c,W] = eval([ODE, '(''DiffEquation'', [(k-1)*block ',Output_Step,' k*block], [Uo; Vo], options)']);             
                w = [w; W(1:length(W)-1, :)];
                tau_ = [tau_; tau_c(1:length(W)-1)];
                W_o = W(length(W), :);
                Uo = W_o(1:4)';
                Vo = W_o(5:8)';

                if get(handles.radiobutton_Pert,'Value') == 1
                    [xo yo] = uv2xy(Uo, Vo);       
                    [Uo Vo] = xy2uv(xo, yo);        
                    [xo yo] = uv2xy(Uo, Vo);
                elseif get(handles.radiobutton_NonPert,'Value') == 1
                    [xo yo] = zw2xy(Uo, Vo);
                    [Uo Vo] = xy2zw(xo, yo);           
                    [xo yo] = zw2xy(Uo, Vo);
                end

%---------------------- SOSTITUZIONE ---------------------------------------------------------                
%{
                Ktot = 1.001;
                while abs(Ktot-1) > 5*eps
                    Ktot = 1/2*sqrt(xo*xo')*(yo*yo'+1) + sqrt(xo*xo')*...
                    Kp(xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4,...
                        deg1, deg2, deg3, deg4, Hp1, Hp2, Hp3, Hp4);
                    xo = xo/Ktot;
                end           
%}
                f = @(z)1/2*sqrt(z^2*xo*xo')*(yo*yo'+1) + sqrt(z^2*xo*xo')*...
                    Kp(z*xo,yo, lambda, epsilon1, epsilon2, epsilon3, epsilon4, epsilon5,...
                        deg1, deg2, deg3, deg4, deg5, Hp1, Hp2, Hp3, Hp4, Hp5) - 1;
                a = fzero(f,1);
                xo =a*xo;
%---------------------------------------------------------------------------------------------        

                if get(handles.radiobutton_Pert,'Value') == 1
                    [Uo Vo] = xy2uv(xo, yo);
                elseif get(handles.radiobutton_NonPert,'Value') == 1
                    [Uo Vo] = xy2zw(xo, yo);
                    Uo = Uo'; Vo = Vo';
                end        

            end
            if (n_cycle*block ~= tau_total)
                [tau_c,W] = eval([ODE, '(''DiffEquation'', [n_cycle*block ',Output_Step,' tau_total], [Uo; Vo], options)']);
                W = [w; W];
                tau_c = [tau_; tau_c];
            else
                W = w;
                tau_c = tau_;
            end
        else            
            [tau_c,W] = eval([ODE, '(''DiffEquation'', [0 ',Output_Step,' tau_total], [Uo; Vo], options)']);
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if get(handles.radiobutton_2D_pert,'Value') == 1
        Calculate_Trajectories
    elseif get(handles.radiobutton_2D_nonpert,'Value') == 1
        Calculate_TrajectoriesNonPert
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    norma_q = sqrt((sum((q_vec.^2)'))');
    sm_ax = norma_q./(2-((sum((p_vec.^2)'))').*norma_q);
    if all(sm_ax > zeros(size(sm_ax)))
% do nothing
    else
        if strcmp(get(handles.warningbox, 'Checked'),'on')
            warndlg('Some values of the semimajor axis are negative or null. It may be that the point is escaping to infinity or is falling into a singularity, so that the semimajor axis is ill defined.')
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   Poincar section
    norma_q = sqrt((sum((q_vec.^2)'))');
    sm_ax = norma_q./(2-((sum((p_vec.^2)'))').*norma_q);
    Delta = scalarp(q_vec,p_vec)./sqrt(sm_ax);
    delta = (sm_ax-norma(q_vec))./sm_ax;
    l = 180/pi*atan2(-delta.*sin(Delta)+Delta.*cos(Delta), delta.*cos(Delta)+Delta.*sin(Delta));
    G_vec = vectorp(q_vec, p_vec);
    G = norma(G_vec);
    Ecc_vec = vectorp(p_vec, G_vec)-q_vec./[norma(q_vec)  norma(q_vec)  norma(q_vec)];
    Ecc = norma(Ecc_vec);
%     if sqrt(G_vec(1:4,1).^2+G_vec(1:4,2).^2) == zeros(4,1);
    if get(handles.radiobutton_2D_system,'Value') == 1
        node = [ones(size(q_vec(:,1)))  zeros(size(q_vec(:,1)))  zeros(size(q_vec(:,1)))];
    else
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        G_prj = sqrt(G_vec(:,1).^2+G_vec(:,2).^2);
        sz = size(G_prj);
        if all(G_prj)
            node = [-G_vec(:,2)./G_prj  G_vec(:,1)./G_prj  zeros(sz)];           
        else
            if any(G_prj)
                node = zeros(sz(1),3);
                node(1,:) = [1  0  0];
                for jsz = 1 : sz(1)
                    if G_prj(jsz) == 0
                        if jsz == 1
                        else
                            node(jsz,:) = node(jsz-1,:);
                        end
                    else
                        node(jsz,:) = [-G_vec(jsz,2)/G_prj(jsz)  G_vec(jsz,1)/G_prj(jsz)  0 ];
                    end
                end
            else
                node = [ones(sz)  zeros(sz)  zeros(sz)];
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    end
    omega = 180/pi*atan2(scalarp(vectorp(node, Ecc_vec), G_vec)./G,...
        scalarp(node, Ecc_vec));
    Action = G./sqrt(sm_ax);           % = normalized G
%     Action = G;
    Angl = omega;

    d = size(Angl, 1);
    k = 1;
    while k < d       
        if sign(l(k)) == sign(l(k+1))           
            k = k+1;         
        else    
            if l(k) < l(k+1)    
                Delta = -l(k)/(l(k+1)-l(k));    
                Ang(j) = Angl(k) + (Angl(k+1)-Angl(k))*Delta;    
                Act(j) = Action(k) + (Action(k+1)-Action(k))*Delta;        
                k = k+1;
                j = j+1;
            else    
                k = k+1;     
            end           
        end    
    end
    if steps_2D ~= 0
        waitbar((Gxxx-G_oinit+step)/(G_ofinal-G_oinit+step))
    end
    clear DiffEquation
    list_number = list_number + 1;
end

G3_string = num2str(G3_o);
figure
if strcmp(get(handles.LargeMS, 'Checked'),'on')
    MarkSize = 6;
else
    MarkSize = 4;
end
plot(Ang(:), Act(:), '.k','MarkerSize',MarkSize)
if strcmp(get(handles.no_degree, 'Checked'),'off')
    Degree_x
end
if get(handles.radiobutton_2D_system,'Value') == 1
    title('Poincar map', 'FontSize',14)
else
    if get(handles.NormG3,'Value') == 1;
        title(['Poincar map \rmwith Normalized \itG_3 = \rm',G3_string], 'FontSize',14)
    elseif get(handles.TrueG3,'Value') == 1;             
        title(['Poincar map \rmwith True \itG_3 = \rm',G3_string], 'FontSize',14)
    end
end
ylabel('\itG', 'FontSize',14), xlabel('\omega   (deg)', 'FontSize',12)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if get(handles.checkbox_append, 'Value') == 1
    global Ang_tot Act_tot
    Ang_tot = [Ang_tot  Ang];
    Act_tot = [Act_tot  Act];
    set(handles.pushbutton_clear, 'Enable', 'on')
    figure
    if strcmp(get(handles.LargeMS, 'Checked'),'on')
        MarkSize = 6;
    else
        MarkSize = 4;
    end
    plot(Ang_tot(:), Act_tot(:), '.k','MarkerSize',MarkSize)
    if strcmp(get(handles.no_degree, 'Checked'),'off')
        Degree_x
    end
    if get(handles.radiobutton_2D_system,'Value') == 1
        title('Total Poincar map', 'FontSize',14)
    else        
        if get(handles.NormG3,'Value') == 1;
            title(['Total Poincar map \rmwith Normalized \itG_3 = \rm',G3_string], 'FontSize',14)
        elseif get(handles.TrueG3,'Value') == 1;             
            title(['Poincar map with True \itG_3 = \rm',G3_string,'   (Append)'], 'FontSize',14)
        end       
    end
    ylabel('\itG', 'FontSize',14), xlabel('\omega   (deg)', 'FontSize',12)
end

close(h)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%