%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct1.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act1x = W(:,1).*cos(W(:,3));
Act1y = W(:,1).*sin(W(:,3));
tau = 1:tau_total;
fid = fopen(['inputAct1_',extstr,'.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau ; Act1x'; Act1y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              Write inputAct2.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Act2x = W(:,2).*cos(W(:,4));
Act2y = W(:,2).*sin(W(:,4));
fid = fopen(['inputAct2_',extstr,'.txt'], 'wt');
fprintf(fid, '%14.10f %14.10f %14.10f\n',...
    [tau ; Act2x'; Act2y']);
fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%----------- Frequency Modulation Indicator (FMI) ----------------------
d = size(W(:,1),1);
numdata = 2^(floor(log2(d)));
threshold = 16;
FMFT_pick = numdata/2;
%---------------------------------------------------------
n_step = str2num(get(handles.Step_FMI1,'String'));
if n_step >= 1
    delta_step = floor((d - FMFT_pick)/n_step);
    for rr = 1:n_step + 1
        fid = fopen(['inputAct1_',num2str(rr),'_',extstr,'.txt'], 'wt');
        fprintf(fid, '%14.10f %14.10f %14.10f\n',...
            [tau(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick);...
            Act1x(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act1y(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)']);
        fclose(fid);
    end
end

%---------------------------------------------------------
n_step = str2num(get(handles.Step_FMI2,'String'));
if n_step >= 1
    delta_step = floor((d - FMFT_pick)/n_step);
    for rr = 1:n_step + 1
        fid = fopen(['inputAct2_',num2str(rr),'_',extstr,'.txt'], 'wt');
        fprintf(fid, '%14.10f %14.10f %14.10f\n',...
            [tau(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick);...
            Act2x(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)';...
        Act2y(((rr - 1)*delta_step + 1) : (rr - 1)*delta_step + FMFT_pick)']);
        fclose(fid);
    end
end

%----------------- End FMI ----------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
